Package: augere.screen
Version: 0.99.2
Date: 2026-04-12
Title: Automatic Generation of Functional Screen Analyses
Description: 
    Implements pipelines for generating functional screen analysis reports in the augere framework.
    This uses voom to test for differential abundance of barcodes with consolidation into gene-level statistics.
    Each pipeline function generates a self-contained Rmarkdown report with all of the steps required to reproduce the analysis.
Authors@R: person("Aaron", "Lun", role=c("cre", "aut"), email="infinite.monkeys.with.keyboards@gmail.com", comment=c(ORCID="0000-0002-3564-4813"))
License: MIT + file LICENSE
Imports: stats, limma, edgeR, metapod, S4Vectors, augere.core,
        augere.de
Suggests: testthat, knitr, rmarkdown, BiocStyle, SummarizedExperiment
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Encoding: UTF-8
URL: https://github.com/augere-bioinfo/augere.screen
BugReports: https://github.com/augere-bioinfo/augere.screen/issues
biocViews: WorkflowManagement, ReportWriting, GeneTarget,
        FunctionalGenomics
git_url: https://git.bioconductor.org/packages/augere.screen
git_branch: devel
git_last_commit: 5df23e6
git_last_commit_date: 2026-04-11
Repository: Bioconductor 3.24
Date/Publication: 2026-05-07
NeedsCompilation: no
Packaged: 2026-05-07 20:20:14 UTC; biocbuild
Author: Aaron Lun [cre, aut] (ORCID: <https://orcid.org/0000-0002-3564-4813>)
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

# Differential abundance in functional screens

Implements a pipeline function to generate parametrized Rmarkdown reports for differential abundance analyses of functional screen data.
The differential abundance analysis is done using `voom()` on the barcode-level counts, followed by consolidation to per-gene statistics for easier interpretation.
The report contains all of the R commands required to reproduce the analysis.

#' @import augere.core
#' @importFrom S4Vectors DataFrame
.generateSummaryCommands <- function(df.name, by.gene.name, summary.threshold, has.LogFC=TRUE) {
    template <- 'local({
    df <- <%= DF_NAME %>
    by.gene <- <%= BY_GENE_NAME %>
    is.sig <- df$FDR <= <%= SUMMARY_THRESHOLD %>
    <%= BODY %>
})'

    signed.cmds <- '
    num.up <- num.down <- integer(length(by.gene))
    ab <- lfc <- rep(NA_real_, length(by.gene))
    for (i in seq_along(by.gene)) {
        current <- by.gene[[i]]
        current.sig <- is.sig[current]
        current.lfc <- df$LogFC[current]
        num.up[i] <- sum(current.sig & current.lfc > 0, na.rm=TRUE)
        num.down[i] <- sum(current.sig & current.lfc < 0, na.rm=TRUE)
        best <- which.min(df$PValue[current])
        if (length(best)) {
            lfc[i] <- current.lfc[best]
            ab[i] <- df$AveAb[current[best]]
        }
    }
    S4Vectors::DataFrame(row.names=names(by.gene), NumUp=num.up, NumDown=num.down, LogFC=lfc, AveAb=ab)
'

    if (has.LogFC) {
        return(replacePlaceholders(template, list(DF_NAME=df.name, BY_GENE_NAME=by.gene.name, SUMMARY_THRESHOLD=deparseToString(summary.threshold), BODY=signed.cmds)))
    }

    conditional.cmds <- '
    if ("LogFC" %in% colnames(df)) {
    <%= PAYLOAD %>
    } else {
        num.sig <- integer(length(by.gene))
        ab <- rep(NA_real_, length(by.gene))
        for (i in seq_along(by.gene)) {
            current <- by.gene[[i]]
            current.sig <- is.sig[current]
            num.sig[i] <- sum(current.sig, na.rm=TRUE)
            best <- which.min(df$PValue[current])
            if (length(best)) {
                ab[i] <- df$AveAb[current[best]]
            }
        }
        S4Vectors::DataFrame(row.names=names(by.gene), NumSig=num.sig, AveAb=ab)
    }
'

    signed.lines <- strsplit(trimws(signed.cmds), '\n')[[1]]
    signed.lines <- sprintf("    %s", signed.lines)
    full.body <- replacePlaceholders(conditional.cmds, list(PAYLOAD=paste(signed.lines, collapse="\n")))
    replacePlaceholders(template, list(DF_NAME=df.name, BY_GENE_NAME=by.gene.name, SUMMARY_THRESHOLD=deparseToString(summary.threshold), BODY=full.body))
}

# library(testthat); library(augere.screen); source("test-generateSummaryCommands.R")

set.seed(123123)
res <- S4Vectors::DataFrame(PValue = rbeta(1000, 1, 20), LogFC = rnorm(1000), AveAb = rnorm(1000))
res$FDR <- p.adjust(res$PValue, method="BH")
genes <- sample(LETTERS, nrow(res), replace=TRUE)
by.gene <- split(seq_along(genes), genes)

test_that("generateSummaryCommands works properly if we know it's signed", {
    cmds <- augere.screen:::.generateSummaryCommands("FOO", "BAR", 0.05, has.LogFC=TRUE)
    expect_false(any(grepl("NumSig", cmds)))

    env <- new.env()
    env$FOO <- res
    env$BAR <- by.gene
    out <- eval(parse(text=cmds), envir=env)

    expect_identical(names(by.gene), rownames(out))
    expect_type(out$NumUp, "integer")
    expect_type(out$NumDown, "integer")

    expect_true(all(out$NumUp + out$NumDown <= lengths(by.gene)))
    expect_gt(sum(res$FDR <= 0.05), 0) # check that we're actually testing something.
    expect_identical(sum(out$NumUp) + sum(out$NumDown), sum(res$FDR <= 0.05))

    expect_type(out$LogFC, "double")
    expect_false(anyNA(out$LogFC))
    expect_true(all(unlist(mapply(function(i, v) v %in% res$LogFC[i], by.gene, out$LogFC))))

    expect_type(out$AveAb, "double")
    expect_false(anyNA(out$AveAb))
    expect_true(all(unlist(mapply(function(i, v) v %in% res$AveAb[i], by.gene, out$AveAb))))
})

test_that("generateSummaryCommands works properly if it might be signed", {
    cmds <- augere.screen:::.generateSummaryCommands("FOO", "BAR", 0.05, has.LogFC=FALSE)
    expect_true(any(grepl("NumSig", cmds)))

    env <- new.env()
    env$FOO <- res
    env$BAR <- by.gene
    out <- eval(parse(text=cmds), envir=env)

    ref.cmds <- augere.screen:::.generateSummaryCommands("FOO", "BAR", 0.05, has.LogFC=TRUE)
    ref.out <- eval(parse(text=ref.cmds), envir=env)
    expect_identical(out, ref.out)

    res$LogFC <- NULL
    env$FOO <- res
    out <- eval(parse(text=cmds), envir=env)

    expect_identical(names(by.gene), rownames(out))
    expect_type(out$NumSig, "integer")
    expect_true(all(out$NumSig <= lengths(by.gene)))
    expect_identical(sum(out$NumSig), sum(res$FDR <= 0.05))

    expect_type(out$AveAb, "double")
    expect_false(anyNA(out$AveAb))
    expect_true(all(unlist(mapply(function(i, v) v %in% res$AveAb[i], by.gene, out$AveAb))))
})

test_that("generateSummaryCommands works properly after sprinkling in some NAs", {
    fail <- logical(nrow(res))
    scapegoat <- genes[1]
    fail[genes == scapegoat] <- TRUE
    fail[sample(nrow(res), 20)] <- TRUE
    res$PValue[fail] <- NA
    res$AveAb[fail] <- NA
    res$FDR[fail] <- NA
    res$LogFC[fail] <- NA

    cmds <- augere.screen:::.generateSummaryCommands("FOO", "BAR", 0.05, has.LogFC=FALSE)

    {
        env <- new.env()
        env$FOO <- res
        env$BAR <- by.gene
        out <- eval(parse(text=cmds), envir=env)
        expect_false(anyNA(out$NumUp))
        expect_false(anyNA(out$NumDown))
        expect_identical(out[scapegoat,"NumUp"], 0L)
        expect_identical(out[scapegoat,"NumDown"], 0L)
        expect_true(is.na(out[scapegoat,"LogFC"]))
        expect_true(is.na(out[scapegoat,"AveAb"]))

        env <- new.env()
        env$FOO <- res[!fail,]
        ok.genes <- genes[!fail]
        env$BAR <- split(seq_along(ok.genes), ok.genes)
        ref.out <- eval(parse(text=cmds), envir=env)
        ref.out <- ref.out[rownames(out),,drop=FALSE]
        rownames(ref.out) <- rownames(out)
        ref.out$NumUp[is.na(ref.out$NumUp)] <- 0L
        ref.out$NumDown[is.na(ref.out$NumDown)] <- 0L
        expect_identical(out, ref.out)
    }

    {
        res0 <- res
        res0$LogFC <- NULL

        env <- new.env()
        env$FOO <- res0
        env$BAR <- by.gene
        out <- eval(parse(text=cmds), envir=env)
        expect_false(anyNA(out$NumSig))
        expect_identical(out[scapegoat,"NumSig"], 0L)
        expect_true(is.na(out[scapegoat,"AveAb"]))

        env <- new.env()
        env$FOO <- res0[!fail,]
        ok.genes <- genes[!fail]
        env$BAR <- split(seq_along(ok.genes), ok.genes)
        ref.out <- eval(parse(text=cmds), envir=env)
        ref.out <- ref.out[rownames(out),,drop=FALSE]
        rownames(ref.out) <- rownames(out)
        ref.out$NumSig[is.na(ref.out$NumSig)] <- 0L
        expect_identical(out, ref.out)
    }
})

#' @importFrom stats p.adjust
#' @importFrom S4Vectors DataFrame
#' @importFrom metapod groupedHolmMin
#' @import augere.core
.generateHolmMinCommands <- function(df.name, genes.name, min.n, min.prop, has.LogFC) {
    template <- 'local({
    df <- <%= DF_NAME %>
    genes <- factor(<%= GENES_NAME %>)
    keep <- !is.na(df$PValue)
    df <- df[keep,,drop=FALSE]
    genes <- genes[keep]

    num.barcodes <- table(genes) 
    output <- S4Vectors::DataFrame(
        row.names = names(num.barcodes),
        NumBarcodes = as.integer(num.barcodes)
    )
    <%= BODY %>
    output
})'

    signed.cmds <- '
    is.up <- df$LogFC > 0
    half.p <- df$PValue / 2
    other.p <- 1 - half.p

    # Computing and combining one-sided p-values for each direction,
    # as we want genes where barcodes change in the same direction.
    p.up <- ifelse(is.up, half.p, other.p)
    holm.up <- metapod::groupedHolmMin(p.up, genes, min.n=<%= MIN_N %>, min.prop=<%= MIN_PROP %>)
    holm.up$p.value <- holm.up$p.value[rownames(output)]

    p.down <- ifelse(!is.up, half.p, other.p)
    holm.down <- metapod::groupedHolmMin(p.down, genes, min.n=<%= MIN_N %>, min.prop=<%= MIN_PROP %>)
    holm.down$p.value <- holm.down$p.value[rownames(output)]

    output$PValue <- pmin(holm.up$p.value, holm.down$p.value, 0.5) * 2
    output$FDR <- p.adjust(output$PValue, method="BH")
    output$Direction <- ifelse(holm.up$p.value < holm.down$p.value, "up", "down")
'
    signed.cmds <- replacePlaceholders(signed.cmds, list(MIN_N=min.n, MIN_PROP=min.prop))

    if (has.LogFC) {
        return(replacePlaceholders(template, list( DF_NAME=df.name, GENES_NAME=genes.name, BODY=signed.cmds)))
    }

    conditional.cmds <- '
    if ("LogFC" %in% colnames(df)) {
    <%= PAYLOAD %>
    } else {
        # If the contrast has no directionality, we just combine p-values as they are.
        holm <- metapod::groupedHolmMin(df$PValue, genes,min.n=<%= MIN_N %>, min.prop=<%= MIN_PROP %>)
        output$PValue <- holm$p.value[rownames(output)]
        output$FDR <- p.adjust(output$PValue, method="BH")
    }
'

    signed.lines <- strsplit(trimws(signed.cmds), '\n')[[1]]
    signed.lines <- sprintf("    %s", signed.lines)
    full.body <- replacePlaceholders(
        conditional.cmds,
        list(
            PAYLOAD=paste(signed.lines, collapse="\n"),
            MIN_N=min.n,
            MIN_PROP=min.prop
        )
    )
    replacePlaceholders(template, list(DF_NAME=df.name, GENES_NAME=genes.name, BODY=full.body))
}

# library(testthat); library(augere.screen); source("test-generateHolmMinCommands.R")

test_that("generateHolmMinCommands works properly if we know it's signed", {
    set.seed(8888)
    res <- S4Vectors::DataFrame(PValue = rbeta(1000, 1, 100), LogFC = rnorm(1000))
    genes <- sample(LETTERS, nrow(res), replace=TRUE)

    cmds <- augere.screen:::.generateHolmMinCommands("FOO", "BAR", min.n=3, min.prop=0.5, has.LogFC=TRUE)
    expect_true(any(grepl("min.n=3", cmds)))
    expect_true(any(grepl("min.prop=0.5", cmds)))
    expect_false(any(grepl("no directionality", cmds)))
    env <- new.env()
    env$FOO <- res
    env$BAR <- genes
    tab <- eval(parse(text=cmds), envir=env)

    expect_identical(sort(rownames(tab)), sort(unique(genes)))
    expect_type(tab$NumBarcodes, "integer")
    expect_type(tab$PValue, "double")
    expect_type(tab$FDR, "double")
    expect_identical(sort(unique(tab$Direction)), c("down", "up"))

    # Checking it does the right thing when all genes are of the same sign, as this is easier to test.
    # In this situation, the sign is effectively irrelevant to the p-value calculation.
    res.up <- res
    res.up$LogFC <- abs(res.up$LogFC)
    env <- new.env()
    env$FOO <- res.up
    env$BAR <- genes
    tab.up <- eval(parse(text=cmds), envir=env)
    expect_true(all(tab.up$Direction == "up"))
    expect_false(identical(tab.up$PValue, tab$PValue))

    res.down <- res
    res.down$LogFC <- -abs(res.down$LogFC)
    env <- new.env()
    env$FOO <- res.down
    env$BAR <- genes
    tab.down <- eval(parse(text=cmds), envir=env)
    expect_true(all(tab.down$Direction == "down"))
    expect_identical(tab.up$PValue, tab.down$PValue)

    res.unknown <- res
    res.unknown$LogFC <- NULL
    cmds.unknown <- augere.screen:::.generateHolmMinCommands("FOO", "BAR", min.n=3, min.prop=0.5, has.LogFC=FALSE) # and in fact it's equivalent to not having a sign at all.
    env <- new.env()
    env$FOO <- res.unknown
    env$BAR <- genes
    tab.unknown <- eval(parse(text=cmds.unknown), envir=env)
    expect_identical(tab.down$PValue, tab.unknown$PValue)
})

test_that("generateHolmMinCommands works properly if we don't know it's signed", {
    set.seed(666)
    res <- S4Vectors::DataFrame(PValue = rbeta(1000, 1, 100), LogFC = rnorm(1000))
    genes <- sample(LETTERS, nrow(res), replace=TRUE)

    cmds <- augere.screen:::.generateHolmMinCommands("FOO", "BAR", min.n=3, min.prop=0.5, has.LogFC=FALSE)
    expect_true(any(grepl("min.n=3", cmds)))
    expect_true(any(grepl("min.prop=0.5", cmds)))
    expect_true(any(grepl("no directionality", cmds)))
    env <- new.env()
    env$FOO <- res
    env$BAR <- genes
    tab <- eval(parse(text=cmds), envir=env)
    expect_type(tab$NumBarcodes, "integer")
    expect_type(tab$PValue, "double")
    expect_type(tab$FDR, "double")
    expect_identical(sort(unique(tab$Direction)), c("down", "up"))

    cmds.known <- augere.screen:::.generateHolmMinCommands("FOO", "BAR", min.n=3, min.prop=0.5, has.LogFC=TRUE)
    env <- new.env()
    env$FOO <- res
    env$BAR <- genes
    tab.known <- eval(parse(text=cmds.known), envir=env)
    expect_identical(tab, tab.known)

    env <- new.env()
    res.nolfc <- res
    res.nolfc$LogFC <- NULL
    env$FOO <- res.nolfc
    env$BAR <- genes
    tab.nolfc <- eval(parse(text=cmds), envir=env)
    expect_false(identical(tab$PValue, tab.nolfc$PValue))
    expect_type(tab$NumBarcodes, "integer")
    expect_type(tab$PValue, "double")
    expect_type(tab$FDR, "double")
    expect_null(tab.nolfc$Direction)
})

test_that("generateHolmMinCommands works with a few NA values", {
    set.seed(7777)
    res <- S4Vectors::DataFrame(PValue = runif(1000), LogFC = rnorm(1000))
    res$PValue[c(1, 1000)] <- NA
    genes <- sample(LETTERS, nrow(res), replace=TRUE)

    cmds <- augere.screen:::.generateHolmMinCommands("FOO", "BAR", min.n=10, min.prop=0.1, has.LogFC=TRUE)
    env <- new.env()
    env$FOO <- res
    env$BAR <- genes
    tab <- eval(parse(text=cmds), envir=env)

    env <- new.env()
    env$FOO <- res[-c(1, 1000),]
    env$BAR <- genes[-c(1, 1000)]
    tab.stripped <- eval(parse(text=cmds), envir=env)
    expect_identical(tab, tab.stripped)

    # But we still preserve the entry in the result.
    purged <- genes[c(1, 1000)]
    res$PValue[genes %in% purged] <- NA

    env <- new.env()
    env$FOO <- res
    env$BAR <- genes
    tab.purged <- eval(parse(text=cmds), envir=env)
    expect_identical(rownames(tab), rownames(tab.purged))
    all.p <- tab$PValue
    all.p[rownames(tab) %in% purged] <- NA
    expect_identical(all.p, tab.purged$PValue)
    all.num <- tab$NumBarcodes
    all.num[rownames(tab) %in% purged] <- 0L
    expect_identical(all.num, tab.purged$NumBarcodes)
})

#' @import augere.core
.normalize <- function(
    norm.control.barcodes, 
    norm.control.gene.field,
    norm.control.genes,
    norm.control.type.field,
    norm.control.types,
    norm.tmm
) {
    template <- system.file("templates", "normalize.Rmd", package="augere.screen", mustWork=TRUE)
    parsed <- parseRmdTemplate(readLines(template))

    if (
        !is.null(norm.control.barcodes) || 
        (!is.null(norm.control.gene.field) && !is.null(norm.control.genes)) ||
        (!is.null(norm.control.type.field) && !is.null(norm.control.types))
    ) {
        parsed[["norm-all"]] <- NULL
        parsed[["norm-none"]] <- NULL
        current <- parsed[["norm-control"]]

        if (is.null(norm.control.barcodes)) {
            current[["barcodes"]] <- NULL
        } else {
            current[["barcodes"]] <- replacePlaceholders(current[["barcodes"]], list(NORM_BARCODES=deparseToString(norm.control.barcodes)))
        }

        if (is.null(norm.control.gene.field) || is.null(norm.control.genes)) {
            current[["genes"]] <- NULL
        } else {
            current[["genes"]] <- replacePlaceholders(
                current[["genes"]],
                list(
                    NORM_GENE_FIELD=deparseToString(norm.control.gene.field),
                    NORM_GENES=deparseToString(norm.control.genes)
                )
            )
        }

        if (is.null(norm.control.type.field) || is.null(norm.control.types)) {
            current[["types"]] <- NULL
        } else {
            current[["types"]] <- replacePlaceholders(
                current[["types"]],
                list(
                    NORM_TYPE_FIELD=deparseToString(norm.control.type.field),
                    NORM_TYPES=deparseToString(norm.control.types)
                )
            )
        }

        if (norm.tmm) {
            current[["lib"]] <- NULL
        } else {
            current[["tmm"]] <- NULL
        }

        parsed[["norm-control"]] <- current

    } else {
        parsed[["norm-control"]] <- NULL
        parsed[["norm-none"]] <- NULL
        current <- parsed[["norm-all"]]

        if (norm.tmm) {
            current[["lib"]] <- NULL
        } else {
            current[["tmm"]] <- NULL
        }

        parsed[["norm-all"]] <- current
    }

    unlist(parsed, use.names=FALSE)
}

# library(testthat); library(augere.screen); source("test-normalize.R")

library(SummarizedExperiment)
rd <- DataFrame(gene = sample(LETTERS, 1000, replace=TRUE), type = rep(c("NTC", "NEG", "other"), c(50, 50, 900)))
means <- 2^rexp(1000)
means[1] <- 0 # to test the filtering.
mat <- matrix(rnbinom(length(means) * 10, mu=means, size=10), nrow=length(means), ncol=10)
rownames(mat) <- sprintf("BARCODE-%s", seq_len(nrow(mat)))
se <- SummarizedExperiment(list(counts=mat), rowData=rd)

library(edgeR)
y <- DGEList(mat)
y$genes <- data.frame(origin=seq_len(nrow(mat)))
y <- y[seq_len(nrow(y)) %% 2 == 0,] # keeping every even barcode, to check for correct handling of non-trivial filters.

ctrl.barcodes <- list(bctrl=sprintf("BARCODE-%s", seq_len(50)))
ctrl.genes <- list(gctrl=LETTERS[1:3])
ctrl.types <- c("NTC", "NEG")

test_that("control-based normalization works as expected with only barcodes", {
    cmds <- augere.screen:::.normalize(
        norm.control.barcodes=ctrl.barcodes,
        norm.control.gene.field=NULL,
        norm.control.type.field=NULL,
        norm.tmm=TRUE
    )
    expect_true(any(grepl("norm.barcodes <-", cmds)))
    expect_false(any(grepl("norm.genes <-", cmds)))
    expect_false(any(grepl("norm.types <-", cmds)))
    expect_true(any(grepl("calcNormFactors", cmds)))

    env <- new.env()
    env$se <- se
    env$y <- y
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

    expect_type(env$y$samples$norm.factors, "double")
    expect_false(all(env$y$samples$norm.factors==1))
    expect_identical(env$use.for.norm, rownames(y) %in% unlist(ctrl.barcodes))
    expect_match(env$norm.meta, "TMM on controls (bctrl)", fixed=TRUE)
})

test_that("control-based normalization works as expected with only genes", {
    cmds <- augere.screen:::.normalize(
        norm.control.barcodes=NULL,
        norm.control.gene.field="gene",
        norm.control.genes=ctrl.genes,
        norm.control.type.field=NULL,
        norm.tmm=TRUE
    )
    expect_false(any(grepl("norm.barcodes <-", cmds)))
    expect_true(any(grepl("norm.genes <-", cmds)))
    expect_false(any(grepl("norm.types <-", cmds)))

    env <- new.env()
    env$se <- se
    env$y <- y
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

    expect_type(env$y$samples$norm.factors, "double")
    expect_false(all(env$y$samples$norm.factors==1))
    expect_identical(env$use.for.norm, rd$gene[y$genes$origin] %in% unlist(ctrl.genes))
    expect_match(env$norm.meta, "TMM on controls (gctrl)", fixed=TRUE)
})

test_that("control-based normalization works as expected with only types", {
    cmds <- augere.screen:::.normalize(
        norm.control.barcodes=NULL,
        norm.control.gene.field=NULL,
        norm.control.type.field="type",
        norm.control.types=ctrl.types,
        norm.tmm=TRUE
    )
    expect_false(any(grepl("norm.barcodes <-", cmds)))
    expect_false(any(grepl("norm.genes <-", cmds)))
    expect_true(any(grepl("norm.types <-", cmds)))

    env <- new.env()
    env$se <- se
    env$y <- y
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

    expect_type(env$y$samples$norm.factors, "double")
    expect_false(all(env$y$samples$norm.factors==1))
    expect_identical(env$use.for.norm, rd$type[y$genes$origin] %in% ctrl.types)
    expect_identical(env$norm.meta, "TMM on controls (NTC, NEG)")
})

test_that("control-based normalization works as expected with everything", {
    cmds <- augere.screen:::.normalize(
        norm.control.barcodes=ctrl.barcodes,
        norm.control.gene.field="gene",
        norm.control.genes=ctrl.genes,
        norm.control.type.field="type",
        norm.control.types=ctrl.types,
        norm.tmm=TRUE
    )
    expect_true(any(grepl("norm.barcodes <-", cmds)))
    expect_true(any(grepl("norm.genes <-", cmds)))
    expect_true(any(grepl("norm.types <-", cmds)))

    env <- new.env()
    env$se <- se
    env$y <- y
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

    expect_type(env$y$samples$norm.factors, "double")
    expect_false(all(env$y$samples$norm.factors==1))
    expect_identical(env$use.for.norm, 
        rownames(y) %in% unlist(ctrl.barcodes) |
        rd$gene[y$genes$origin] %in% unlist(ctrl.genes) |
        rd$type[y$genes$origin] %in% ctrl.types
    )
    expect_identical(env$norm.meta, "TMM on controls (bctrl, gctrl, NTC, NEG)")
})

test_that("control-based normalization works with library sizes", {
    cmds <- augere.screen:::.normalize(
        "control",
        norm.control.barcodes=ctrl.barcodes,
        norm.control.gene.field=NULL,
        norm.control.type.field=NULL,
        norm.tmm=FALSE
    )
    expect_true(any(grepl("norm.barcodes <-", cmds)))
    expect_false(any(grepl("norm.genes <-", cmds)))
    expect_false(any(grepl("norm.types <-", cmds)))
    expect_false(any(grepl("calcNormFactors", cmds)))

    env <- new.env()
    env$se <- se
    env$y <- y
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

    expect_type(env$y$samples$norm.factors, "double")
    expect_false(all(env$y$samples$norm.factors==1))
    expect_identical(env$norm.meta, "library size on controls (bctrl)")
})

test_that("normalization on all barcodes works as expected", {
    {
        cmds <- augere.screen:::.normalize(
            norm.control.barcodes=NULL,
            norm.control.gene.field=NULL,
            norm.control.type.field=NULL,
            norm.tmm=TRUE
        )
        expect_false(any(grepl("norm.barcodes <-", cmds)))
        expect_false(any(grepl("norm.genes <-", cmds)))
        expect_false(any(grepl("norm.types <-", cmds)))
        expect_true(any(grepl("calcNormFactors", cmds)))

        env <- new.env()
        env$se <- se
        env$y <- y
        tmp <- tempfile()
        dir.create(tmp)
        augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

        expect_type(env$y$samples$norm.factors, "double")
        expect_false(all(env$y$samples$norm.factors==1))
        expect_identical(env$norm.meta, "TMM on all barcodes")
    }

    {
        cmds <- augere.screen:::.normalize(
            norm.control.barcodes=NULL,
            norm.control.gene.field=NULL,
            norm.control.type.field=NULL,
            norm.tmm=FALSE
        )
        expect_false(any(grepl("norm.barcodes <-", cmds)))
        expect_false(any(grepl("norm.genes <-", cmds)))
        expect_false(any(grepl("norm.types <-", cmds)))
        expect_false(any(grepl("calcNormFactors", cmds)))

        env <- new.env()
        env$se <- se
        env$y <- y
        tmp <- tempfile()
        dir.create(tmp)
        augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=cmds, env=env)

        expect_type(env$y$samples$norm.factors, "double")
        expect_true(all(env$y$samples$norm.factors==1))
        expect_identical(env$norm.meta, "library size on all barcodes")
    }
})

#' Differential abundance for functional screens
#'
#' Use \code{\link[limma]{voom}} to test for differential abundance of barcodes in a functional screen.
#' 
#' @param x A \link[SummarizedExperiment]{SummarizedExperiment} object containing read counts for each barcode (row) and sample (column).
#' Alternatively, the output of \code{\link[augere.core]{wrapInput}} that refers to a SummarizedExperiment.
#' @inheritParams augere.de::runVoom
#' @param filter.reference.factor String specifying \code{\link[SummarizedExperiment]{colData}(se)} column that indicates whether a sample is a reference.
#' This is used to filter out barcodes that are not present in the original barcode library.
#' @param filter.reference.levels Character vector containing the reference levels in the \code{filter.reference.factor} column.
#' Only used if \code{filter.reference.factor} is supplied.
#' @param filter.num.mads Number specifying the number of median absolute deviations below the median to define an outlier threshold for filtering barcodes.
#' Only used if \code{filter.reference.factor} is supplied.
#' @param filter.default Boolean indicating whether to filter barcodes using the default \pkg{edgeR} method, i.e., \code{\link[edgeR]{filterByExpr}}.
#' If \code{TRUE} and \code{filter.reference.factor} is supplied, the default filtering is applied in addition to the reference-based filtering.
#' Otherwise, it is applied alone. 
#' @param norm.control.barcodes A named list of character vectors containing one or more sets of control barcodes.
#' Each vector should contain the names of barcodes, corresponding to the row names of \code{se}.
#' The names of the vectors will be stored in the metadata.
#' @param norm.control.genes A named list containing one or more sets of control genes.
#' Each vector should contain the names of genes, corresponding to the entries of the \code{gene.field} column.
#' The names of the vectors will be stored in the metadata.
#' Only used if \code{gene.field} is supplied.
#' @param norm.control.type.field String specifying the \code{\link[SummarizedExperiment]{rowData}(se)} column containing the feature type for each barcode.
#' @param norm.control.types Character vector containing the control feature types in the \code{norm.type.field} column. 
#' Only used if \code{norm.type.field} is supplied.
#' @param norm.tmm Boolean indicating whether TMM normalization should be used.
#' If \code{FALSE}, normalization is instead performed using the library size for each sample.
#' @param gene.field String specifying the \code{rowData(se)} column that contains the gene identity for each barcode.
#' If \code{NULL}, consolidation of barcode-level statistics into per-gene inferences will not be performed.
#' @param consolidation Character vector specifying the consolidation method(s) to convert per-barcode statistics into per-gene results.
#' This can be zero, one or more of:
#' \itemize{
#' \item \code{"simes"}, which uses \code{\link[metapod]{groupedSimes}} to combine barcode-level p-values into a single per-gene p-value. 
#' This is the most sensitive approach for detecting a small number of barcodes (possibly just 1) that are differentially abundant.
#' \item \code{"holm-min"}, which uses \code{\link[metapod]{groupedHolmMin}} to combine barcode-level p-values into a single per-gene p-value. 
#' This should be used when a minimum number/proportion of barcodes for a gene is expected to exhibit differential abundance. 
#' \item \code{"fry"}, which uses \code{\link[limma]{fry}} to test for differential abundance across all barcodes for a gene.
#' This favors consistent differences across the majority of barcodes for a given gene.
#' However, it is not compatible with ANOVA-like contrasts and will ignore any \code{lfc.threshold > 0}.
#' }
#' Only used if \code{gene.field} is supplied.
#' @param report.summary Boolean indicating whether to report barcode-level summaries within the per-gene data frames.
#' Only used if \code{gene.field} is supplied.
#' @param summary.threshold Number specifying the FDR threshold when summarizing the number of significant barcodes per gene.
#' Only used if \code{report.summary=TRUE}.
#' @param holm.min.n Integer specifying the minimum number of significant barcodes per gene when \code{consolidation="holm"},
#' see the \code{min.sig.n=} in \code{?\link[metapod]{groupedHolmMin}} for details.
#' @param holm.min.prop Integer specifying the minimum proportion of significant barcodes per gene when \code{consolidation="holm"},
#' see the \code{min.sig.prop=} in \code{?\link[metapod]{groupedHolmMin}} for details.
#' @param fry.args Named list of additional arguments to pass to \code{\link[limma]{fry}}.
#' @param gene.data Character vector containing the names of \code{\link[SummarizedExperiment]{rowData}(se)} columns to add to the per-gene result tables.
#' If a gene has multiple barcodes, the row corresponding to the first barcode is used.
#' 
#' @return
#' A Rmarkdown report named \code{report.Rmd} is written inside \code{output.dir} that contains the analysis commands.
#'
#' If \code{dry.run=FALSE}, a list is returned containing:
#' \itemize{
#' \item \code{barcode}, a named list of \link[S4Vectors]{DataFrame}s containing barcode-level result tables.
#' Each DataFrame corresponds to a comparison/contrast where each row corresponds to a barcode (i.e., row) in \code{se}.
#' Each DataFrame contains the following columns:
#' \itemize{
#' \item \code{AveAb}, the average abundance.
#' \item \code{t}, the t-statistic.
#' (For non-ANOVA-like contrasts only.)
#' \item \code{F}, the F-statistic.
#' (For ANOVA-like contrasts only.)
#' \item \code{LogFC}, the log-fold change.
#' (For non-ANOVA-like contrasts only.)
#' \item \code{LogFC.<COLUMN>}, the log-fold change corresponding to each column of the contrast matrix.
#' (For ANOVA-like contrasts only.)
#' \item \code{PValue}, the p-value;
#' \item \code{FDR}, the Benjamini-Hochberg-adjusted p-value.
#' }
#' \item \code{gene}, a named list of lists containing one entry per method in \code{consolidation}.
#' Each inner list contains one \link[S4Vectors]{DataFrame} per contrast where each row corresponds to a gene (not barcode). 
#' Each DataFrame contains at least the following columns:
#' \itemize{
#' \item \code{NumBarcodes}, the number of barcodes per gene (possibly after filtering).
#' \item \code{PValue}, the p-value for differential abundance across all barcodes for the gene.
#' \item \code{FDR}, the Benjamini-Hochberg-adjusted p-value.
#' \item \code{Direction}, the overall direction of change for all barcodes of the gene.
#' (For non-ANOVA-like contrasts only.)
#' \item \code{NumUp}, the number of barcodes with a significant increase in abundance.
#' (For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
#' \item \code{NumDown}, the number of barcodes with a significant decrease in abundance.
#' (For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
#' \item \code{LogFC}, the log-fold change of the barcode with the lowest p-value.
#' (For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
#' \item \code{NumSig}, the number of significant barcodes.
#' (For ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
#' \item \code{AveAb}, the average abundance of the barcode with the lowest p-value.
#' }
#' Only reported if \code{gene.field} is not \code{NULL}.
#' \item \code{normalized}, a copy of \code{x} with normalized abundance values, possibly subsetted by sample.
#' This contains:
#' \itemize{
#' \item \code{lib.size} and \code{norm.factors} columns in its \code{\link[SummarizedExperiment]{colData}},
#' containing the library sizes and normalization factors, respectively.
#' \item a \code{retained} column in its \code{\link[SummarizedExperiment]{rowData}},
#' indicating whether a gene was retained after filtering.
#' \item a \code{logcounts} assay, containing the log-normalized counts.
#' }
#' \code{normalized} may be subsetted by sample, depending on \code{subset.factor}, \code{subset.group}, etc.
#' }
#' If \code{save.results=TRUE}, the results are saved in a \code{results} directory inside \code{output}.
#'
#' If \code{dry.run=TRUE}, \code{NULL} is returned.
#' Only the Rmarkdown report is saved to file.
#'
#' @section Reference filtering:
#' A reference sample should represent the barcode distribution before any perturbation, e.g., time zero in a time course.
#' All barcodes should have similar abundances in the reference samples as they should be present at the same molarity in the original barcode library.
#' If a barcode has very low abundance, it was probably missing from the original library due to some manufacturing defect.
#'
#' To identify these low outliers, we compute the average abundance across reference samples for each barcode.
#' We define a filtering threshold based on the median absolute deviation (MAD) below the median of the average abundances across barcodes.
#' Barcodes with average abundances below this threshold are discarded.
#' 
#' % This approach is a little suspect if the reference samples are being compared as it's not independent of the comparison.
#' % Specifically, we could enrich for barcodes that are spuriously upregulated in the reference.
#' % Fortunately, the density of barcodes at the outlier filter boundary should be so low that any biases should not be noticeable.
#'
#' We also use \code{\link[edgeR]{filterByExpr}} to remove low-abundance barcodes. 
#' This ensures that all remaining barcodes have sufficiently large counts for \code{\link[limma]{voom}}, 
#' especially if the reference samples themselves are not used in the rest of the analysis.
#'
#' @section Control normalization:
#' Control barcodes might not target any gene (non-targeting controls, or NTCs) or they might target non-essential genes (NEGs).
#' We assume that such barcodes do not genuinely change in abundance across conditions, allowing us to use them to compute normalization factors.
#' The choice of control barcodes can be made by one or more of the \code{norm.barcodes}, \code{norm.genes} and \code{norm.types} arguments.
#' If more than one of these modes is provided, the union of barcodes is used. 
#'
#' By default, we use TMM normalization (see \code{\link[edgeR]{calcNormFactors}}) on the control barcodes. 
#' This avoids composition biases and provides some robustness against changes in abundance due to inadvertent biological activity.
#' If \code{norm.tmm=FALSE}, we instead use the total sum of counts across the controls to derive normalization factors.
#' This can be more precise but is more sensitive to genuine changes in abundance.
#'
#' If no control barcodes are specified, normalization uses all barcodes that remain after filtering.
#' If \code{norm.tmm=TRUE}, TMM normalization is performed on all (filtered) barcodes.
#' Otherwise, the total sum of counts across all (filtered) barcodes is used.
#'
#' @author Aaron Lun, Jean-Philippe Fortin
#'
#' @examples
#' # Creating an example dataset.
#' mu <- 2^runif(1000, 0, 5)
#' grouping <- rep(c("A", "B", "ctrl"), each=3)
#' counts <- matrix(rnbinom(length(mu)* length(grouping), mu=mu, size=20), ncol=length(grouping))
#' rownames(counts) <- sprintf("BARCODE-%s", seq_along(mu))
#' 
#' library(SummarizedExperiment)
#' se <- SummarizedExperiment(list(counts=counts))
#' rowData(se)$type <- sample(c("NTC", "NEG", "other"), length(mu), replace=TRUE)
#' rowData(se)$gene <- paste0("GENE-", sample(LETTERS, length(mu), replace=TRUE))
#' colData(se)$group <- grouping
#'
#' output <- tempfile()
#' res <- runScreen(
#'     se,
#'     groups="group",
#'     comparisons=c("A", "B"),
#'     norm.control.type.field="type",
#'     norm.control.types="NEG",
#'     filter.reference.factor="group",
#'     filter.reference.levels="ctrl",
#'     gene.field="gene",
#'     output.dir=output
#' )
#'
#' list.files(output, recursive=TRUE)
#' res$barcode[[1]]
#' res$gene$simes[[1]]
#' res$normalized
#' 
#' @export
#' @import augere.core
#' @importFrom augere.de processContrastMetadata
#' @importFrom limma voom
#' @importFrom edgeR calcNormFactors
runScreen <- function( 
    x,
    groups,
    comparisons,
    covariates = NULL,
    block = NULL,
    subset.factor = NULL,
    subset.levels = NULL,
    subset.groups = TRUE,
    design = NULL,
    contrasts = NULL,
    dc.block = NULL,
    robust = TRUE,
    trend = FALSE,
    quality = TRUE,
    lfc.threshold = 0,
    filter.reference.factor = NULL,
    filter.reference.levels = NULL,
    filter.num.mads = 3,
    filter.default = TRUE,
    norm.control.barcodes = NULL, 
    norm.control.genes = NULL,
    norm.control.type.field = NULL,
    norm.control.types = NULL,
    norm.tmm = TRUE,
    gene.field = NULL,
    report.summary = TRUE,
    summary.threshold = 0.05,
    consolidation = c("simes", "fry", "holm-min"),
    fry.args = list(),
    holm.min.n = 3,
    holm.min.prop = 0.3,
    assay = 1,
    row.data = gene.field,
    gene.data = NULL,
    metadata = NULL,
    output.dir = "voom",
    author = NULL,
    dry.run = FALSE,
    save.results = TRUE,
    suppress.plots = FALSE
) {
    restore.fun <- resetInputCache()
    on.exit(restore.fun(), after=FALSE, add=TRUE)

    if (is.null(author)) {
        author <- Sys.info()[["user"]]
    }

    dir.create(output.dir, showWarnings=FALSE, recursive=FALSE)
    fname <- file.path(output.dir, "report.Rmd")

    ########################################
    ### Initialization and normalization ###
    ########################################

    common.start <- .initialize(
        x=x,
        method="voom",
        assay=assay,
        groups=groups,
        comparisons=comparisons,
        covariates=covariates,
        block=block,
        subset.factor=subset.factor,
        subset.levels=subset.levels,
        subset.groups=subset.groups,
        filter.reference.factor=filter.reference.factor,
        filter.reference.levels=filter.reference.levels,
        filter.num.mads=filter.num.mads,
        filter.default=filter.default,
        design=design,
        contrasts=contrasts,
        author=author
    )
    writeRmd(common.start$text, file=fname)
    contrast.info <- common.start$contrasts

    norm <- .normalize(
        norm.control.barcodes=norm.control.barcodes,
        norm.control.gene.field=gene.field,
        norm.control.genes=norm.control.genes,
        norm.control.type.field=norm.control.type.field,
        norm.control.types=norm.control.types,
        norm.tmm=norm.tmm
    )
    writeRmd(norm, file=fname, append=TRUE)

    ###################################
    ### Barcode-level model fitting ###
    ###################################

    template <- system.file("templates", "screen.Rmd", package="augere.screen", mustWork=TRUE)
    parsed <- parseRmdTemplate(readLines(template))
    replacements <- list(ASSAY = deparseToString(assay))

    if (common.start$mds.use.group) {
        parsed[["mds-ungrouped"]] <- NULL
    } else {
        parsed[["mds-grouped"]] <- NULL
    }

    lm.args <- character(0)
    if (!is.null(dc.block)) {
        parsed[["voom"]] <- NULL
        replacements$DUPCOR_BLOCK <- deparseToString(dc.block)
        lm.args <- c("block=dc.block", "correlation=dc$consensus.correlation")
        replacements$LM_OPTS <- paste(c("", lm.args), collapse=", ")
    } else {
        parsed[["duplicate-correlation"]] <- NULL
        replacements$LM_OPTS <- ""
    }

    if (quality) {
        replacements$VOOM_CMD <- "voomWithQualityWeights"
    } else {
        replacements$VOOM_CMD <- "voom"
        parsed[["quality-text"]] <- NULL
    }

    eb.args <- ""
    if (trend) {
        eb.args <- c(eb.args, "trend=TRUE")
    }

    if (robust) {
        eb.args <- c(eb.args, "robust=TRUE")
        replacements$EXTRA_EB_CAPT <- " with outliers marked in red"
    } else {
        replacements$EXTRA_EB_CAPT <- ""
        parsed[["robust-text"]] <- NULL
    }

    replacements$EB_OPTS <- paste(eb.args, collapse=", ")

    merge.metadata <- !is.null(metadata)
    if (merge.metadata) {
        parsed[["create-common-metadata"]] <- replacePlaceholders(parsed[["create-common-metadata"]], list(COMMON_METADATA=deparseToString(metadata)))
    } else {
        parsed[["create-common-metadata"]] <- NULL
    }

    contrasts <- vector("list", length(contrast.info))
    save.names <- character()
    fig.chunks <- character()
    author.txt <- deparseToString(as.list(author))
    replacements$AUTHOR <- author.txt

    if (length(consolidation)) {
        # I dunno, match.arg() doesn't like zero-length inputs.
        consolidation <- match.arg(consolidation, several.ok=TRUE)
    }
    if (is.null(gene.field) || length(consolidation) == 0L) {
        consolidation <- character(0)
        report.summary <- FALSE
        parsed[["gene-output"]] <- NULL

    } else {
        replacements$GENE_FIELD <- deparseToString(gene.field)

        if (!report.summary) {
            parsed[["gene-output"]][["create-summary-indices"]] <- NULL
        }

        if (!("simes" %in% consolidation)) {
            parsed[["gene-output"]][["init-simes"]] <- NULL
        }

        if (!("fry" %in% consolidation)) {
            parsed[["gene-output"]][["init-fry"]] <- NULL
            parsed[["gene-output"]][["create-fry-indices"]] <- NULL
        } else {
            fry.args <- vapply(names(fry.args), function(n) sprintf("%s=%s", n, deparseToString(fry.args[[n]])), FUN.VALUE="")
            fry.args <- c(fry.args, eb.args, lm.args)
        }

        if (!("holm-min" %in% consolidation)) {
            parsed[["gene-output"]][["init-holm-min"]] <- NULL
        }

        if (is.null(gene.data)) {
            parsed[["gene-output"]][["create-gene-annotation"]] <- NULL
        } else {
            replacements$GENE_DATA_FIELDS <- deparseToString(gene.data)
        }
    }

    for (i in seq_along(contrast.info)) {
        copy <- parsed$contrast

        ###############################
        ### Barcode-level contrasts ###
        ###############################

        current <- contrast.info[[i]]
        copy[["contrast-command"]] <- current$commands

        if (lfc.threshold == 0) {
            copy[["lfc-contrast"]] <- NULL
        } else {
            copy[["no-lfc-contrast"]] <- NULL
            copy[["lfc-contrast"]] <- replacePlaceholders(
                copy[["lfc-contrast"]],
                list(
                    EB_OPTS=replacements$EB_OPTS,
                    LFC_THRESHOLD=deparseToString(lfc.threshold)
                )
            )
        }

        if (is.null(row.data)) {
            copy[["attach-rowdata"]] <- NULL
        } else {
            copy[["attach-rowdata"]] <- replacePlaceholders(copy[["attach-rowdata"]], list(ROWDATA_FIELDS=deparseToString(row.data)))
        }

        meta.cmds <- processContrastMetadata(current)
        meta.cmds[1] <- paste0("contrast=", meta.cmds[1])
        meta.cmds <- sprintf("%s%s", strrep(" ", 8), meta.cmds)
        meta.cmds[length(meta.cmds)] <- paste0(meta.cmds[length(meta.cmds)], ",")

        decorate_metadata <- function(txt) {
            txt[["diff-metadata"]] <- meta.cmds
            if (is.null(subset.factor)) {
                txt[["subset-metadata"]] <- NULL
            }
            if (!merge.metadata) {
                txt[["merge-metadata"]] <- NULL
            } else {
                txt[["no-merge-metadata"]] <- NULL
            }
            txt
        }

        copy <- decorate_metadata(copy)

        ################################
        ### Gene-level consolidation ###
        ################################

        has.LogFC <- current$type %in% c("versus", "covariate")

        if (report.summary) {
            copy[["create-summary"]] <- replacePlaceholders(
                copy[["create-summary"]],
                list(SUMMARY_CMDS = paste(.generateSummaryCommands("barcode.df", "by.gene", deparseToString(summary.threshold), has.LogFC=has.LogFC), collapse="\n"))
            )
        } else {
            copy[["create-summary"]] <- NULL
        }

        if ("simes" %in% consolidation) {
            simes.cmd <- .generateSimesCommands(df.name="barcode.df", genes.name="gene.ids", has.LogFC=has.LogFC)
            save.name <- paste0("save-simes-", i)
            save.names <- c(save.names, save.name)
            copy$simes <- decorate_metadata(copy$simes)
            copy$simes <- replacePlaceholders(copy$simes, list(SIMES_CMD=simes.cmd, SAVING_CHUNK_NAME=save.name), error=FALSE)

            if (is.null(gene.data)) {
                copy$simes[["gene-annotation"]] <- NULL
            }
            if (!report.summary) {
                copy$simes[["barcode-summaries"]] <- NULL
            }
        } else {
            copy$simes <- NULL
        }

        if ("fry" %in% consolidation) {
            save.name <- paste0("save-fry-", i)
            save.names <- c(save.names, save.name)
            copy$fry <- decorate_metadata(copy$fry)
            copy$fry <- replacePlaceholders(
                copy$fry,
                list(
                    FRY_OPTS=paste(sprintf(",\n    %s", fry.args), collapse=""),
                    SAVING_CHUNK_NAME=save.name
                ),
                error=FALSE
            )

            if (is.null(gene.data)) {
                copy$fry[["gene-annotation"]] <- NULL
            }
            if (!report.summary) {
                copy$fry[["barcode-summaries"]] <- NULL
            }
        } else {
            copy[["fry"]] <- NULL
        }

        if ("holm-min" %in% consolidation) {
            holm.cmd <- .generateHolmMinCommands(df.name="barcode.df", genes.name="gene.ids", min.n=holm.min.n, min.prop=holm.min.prop, has.LogFC=has.LogFC)
            save.name <- paste0("save-holm-", i)
            save.names <- c(save.names, save.name)
            copy$`holm-min` <- decorate_metadata(copy$`holm-min`)
            copy$`holm-min` <- replacePlaceholders(copy$`holm-min`, list(HOLM_CMD=holm.cmd, SAVING_CHUNK_NAME=save.name), error=FALSE)

            if (is.null(gene.data)) {
                copy$`holm-min`[["gene-annotation"]] <- NULL
            }
            if (!report.summary) {
                copy$`holm-min`[["barcode-summaries"]] <- NULL
            }
        } else {
            copy[["holm-min"]] <- NULL
        }

        save.name <- paste0("save-barcode-", i)
        save.names <- c(save.names, save.name)
        contrasts[[i]] <- replacePlaceholders(
            copy,
            list(
                AUTHOR=author.txt,
                EB_OPTS=replacements$EB_OPTS,
                CONTRAST_NAME_SIMPLE=current$title,
                CONTRAST_NAME_DEPARSED=deparseToString(current$title),
                CONTRAST_INDEX=i,
                SAVING_CHUNK_NAME=save.name
            )
        )

        fig.chunks <- c(
            fig.chunks,
            paste0("plot-md-", i),
            paste0("plot-volcano-", i)
        )
    }

    parsed$contrast <- contrasts

    # Some final editing of the normalized SE's metadata.
    if (is.null(subset.factor)) {
        parsed[["subset-metadata"]] <- NULL
    }
    if (!merge.metadata) {
        parsed[["merge-metadata"]] <- NULL
    } else {
        parsed[["no-merge-metadata"]] <- NULL
    }

    parsed <- replacePlaceholders(parsed, replacements)
    writeRmd(parsed, file=fname, append=TRUE)

    if (dry.run) {
        return(NULL)
    }

    if (save.results) {
        skip.chunks <- NULL
    } else {
        skip.chunks <- c("save-directory", save.names, "save-norm")
    }

    if (suppress.plots) {
        skip.chunks <- c(
            skip.chunks,
            "plot-md-norm",
            "plot-mds",
            "plot-sa",
            fig.chunks
        )
    }

    env <- new.env()
    compileReport(fname, env=env, skip.chunks=skip.chunks, suppress.plots=suppress.plots)

    gene.info <- list(
        simes=env$all.simes,
        fry=env$all.fry,
        `holm-min`=env$all.holm.min
    )
    gene.info <- gene.info[!vapply(gene.info, is.null, TRUE)]

    list(
        barcode=env$all.barcodes,
        gene=gene.info,
        normalized=env$normalized
    )
}

# library(testthat); library(augere.screen); source("test-runScreen.R")

library(SummarizedExperiment)
cd <- DataFrame(group = rep(LETTERS[1:4], each=5), age=1:20, batch=factor(rep(1:5, 4)))
means <- 2^runif(1000, 1, 10)
means[1] <- 0 # to test the filtering.
mat <- matrix(rnbinom(length(means) * nrow(cd), mu=means, size=10), nrow=length(means), ncol=nrow(cd))
se <- SummarizedExperiment(list(counts=mat), colData=cd)
rowData(se)$type <- sample(c("NTC", "NEG", "other"), length(means), replace=TRUE)
rowData(se)$gene <- paste0("GENE-", sample(LETTERS, length(means), replace=TRUE))

test_that("runScreen works with defaults, no genes", {
    output <- tempfile()
    pdf(file=NULL)
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), output.dir=output)
    dev.off()

    expect_identical(length(res$gene), 0L) 
    expect_identical(length(res$barcode), 1L) 
    expect_identical(names(res$barcode), "Increase in `A` over `B`")
    expect_identical(rownames(res$barcode[[1]]), rownames(se))
    expect_identical(rownames(se), rownames(res$normalized))

    expect_identical(rownames(res$barcode[[1]]), rownames(se))
    expect_type(res$barcode[[1]]$PValue, "double")
    expect_type(res$barcode[[1]]$LogFC, "double")
    expect_type(res$barcode[[1]]$AveAb, "double")
    expect_type(res$barcode[[1]]$FDR, "double")

    roundtrip <- augere.core::readResult(file.path(output, "results", "barcode-1"))
    expect_identical(roundtrip$x, res$barcode[[1]])
    expect_match(roundtrip$metadata$title, "Increase")
    expect_identical(roundtrip$metadata$differential_barcode_abundance$contrast$left, list("A"))
    expect_identical(roundtrip$metadata$differential_barcode_abundance$contrast$right, list("B"))
    expect_match(roundtrip$metadata$differential_barcode_abundance$normalization, "TMM")

    roundtrip <- augere.core::readResult(file.path(output, "results", "normalized"))
    expect_identical(dimnames(roundtrip$x), dimnames(res$normalized))
    expect_match(roundtrip$metadata$title, "Normalized")
})

test_that("runScreen works with default genes", {
    output <- tempfile()
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), gene.field="gene", output.dir=output, suppress.plots=TRUE)
    expect_identical(names(res$gene), c("simes", "fry", "holm-min"))

    expected.names <- sort(unique(rowData(se)$gene))
    for (meth in names(res$gene)) {
        expect_match(names(res$gene[[meth]]), "Increase in")
        df <- res$gene[[meth]][[1]]
        expect_identical(rownames(df), expected.names)

        expect_type(df$NumBarcodes, "integer")
        expect_type(df$NumUp, "integer")
        expect_type(df$NumDown, "integer")
        expect_type(df$PValue, "double")
        expect_type(df$LogFC, "double")
        expect_type(df$FDR, "double")
        expect_true(all(df$Direction %in% c("up", "down", NA)))

        roundtrip <- augere.core::readResult(file.path(output, "results", paste0(meth, "-1")))
        expect_identical(roundtrip$metadata$differential_gene_abundance$method, meth)
        expect_match(roundtrip$metadata$differential_gene_abundance$normalization, "TMM")
    }
})

test_that("runScreen works with log-fold changes", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), lfc.threshold=0.5, output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)

    fname <- readLines(file.path(tmp, "report.Rmd"))
    expect_true(any(grepl("treat\\(.*lfc=0.5", fname)))
})

test_that("runScreen works with custom subsetting", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), subset.factor="batch", subset.levels=c("1","3","5"), gene.field="gene", output.dir=tmp, suppress.plots=TRUE)

    # Subsetting works correctly.
    expect_lt(ncol(out$normalized), ncol(se))
    expect_identical(unique(out$normalized$batch), factor(c("1", "3", "5"), 1:5))

    meta <- augere.core::readResult(file.path(tmp, "results", "barcode-1"))$metadata
    expect_identical(meta$differential_barcode_abundance$subset, "batch IN (1,3,5)")
    meta <- augere.core::readResult(file.path(tmp, "results", "normalized"))$metadata
    expect_identical(meta$summarized_experiment$subset, "batch IN (1,3,5)")

    for (meth in names(out$gene)) {
        roundtrip <- augere.core::readResult(file.path(tmp, "results", paste0(meth, "-1")))
        expect_identical(roundtrip$metadata$differential_gene_abundance$subset, "batch IN (1,3,5)")
    }
})

test_that("runScreen works with some other filtering parameters", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), filter.reference.factor="group", filter.reference.levels=c("C", "D"), output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)
    expect_false(rowData(out$normalized)$retained[1])

    out <- runScreen(se, group="group", comparisons=c("C", "A"), filter.default=FALSE, output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)
    expect_true(rowData(out$normalized)$retained[1])
})

test_that("runScreen works with control-based normalization", {
    # Don't suppress plots, we want to check that the normalization-related plots for each strategy are generated correctly.
    tmp <- tempfile()
    pdf(file=NULL)
    out <- runScreen(se, group="group", comparisons=c("C", "A"), norm.control.type.field="type", norm.control.types=c("NTC", "NEG"), output.dir=tmp)
    dev.off()

    meta <- augere.core::readResult(file.path(tmp, "results", "barcode-1"))$metadata
    expect_identical(meta$differential_barcode_abundance$normalization, "TMM on controls (NTC, NEG)")

    meta <- augere.core::readResult(file.path(tmp, "results", "normalized"))$metadata
    expect_identical(meta$summarized_experiment$normalization, "TMM on controls (NTC, NEG)")

    for (meth in names(out$gene)) {
        roundtrip <- augere.core::readResult(file.path(output, "results", paste0(meth, "-1")))
        expect_identical(roundtrip$metadata$differential_gene_abundance$normalization, "TMM on controls (NTC, NEG)")
    }

    tmp <- tempfile()
    pdf(file=NULL)
    out <- runScreen(se, group="group", comparisons=c("C", "A"), norm.control.type.field="type", norm.control.types=c("NTC", "NEG"), norm.tmm=FALSE, output.dir=tmp)
    dev.off()

    meta <- augere.core::readResult(file.path(tmp, "results", "barcode-1"))$metadata
    expect_identical(meta$differential_barcode_abundance$normalization, "library size on controls (NTC, NEG)")
})

test_that("runScreen works with multiple comparisons", {
    # Don't suppress plotting, we want to check that multiple plots are correctly generated.
    tmp <- tempfile()
    pdf(file=NULL)
    out <- runScreen(se, group="group", comparisons=list(foo=c("C", "A"), bar=c("B", "D")), gene.field="gene", output.dir=tmp)
    dev.off()

    expect_identical(names(out$barcode), c("foo", "bar"))
    expect_match(augere.core::readResult(file.path(tmp, "results", "barcode-1"))$meta$title, "foo")
    expect_match(augere.core::readResult(file.path(tmp, "results", "barcode-2"))$meta$title, "bar")
    expect_match(augere.core::readResult(file.path(tmp, "results", "fry-1"))$meta$title, "foo")
    expect_match(augere.core::readResult(file.path(tmp, "results", "simes-2"))$meta$title, "bar")

    # Comparing to the single-comparison results.
    tmp1 <- tempfile()
    alone1 <- runScreen(se, group="group", comparisons=c("C", "A"), gene.field="gene", subset.group=FALSE, output.dir=tmp1, save.results=FALSE, suppress.plots=TRUE)
    expect_identical(out$barcode$foo, alone1$barcode[[1]])
    expect_identical(out$gene$simes$foo, alone1$gene$simes[[1]])

    tmp2 <- tempfile()
    alone2 <- runScreen(se, group="group", comparisons=c("B", "D"), gene.field="gene", subset.group=FALSE, output.dir=tmp2, save.results=FALSE, suppress.plots=TRUE)
    expect_identical(out$barcode$bar, alone2$barcode[[1]])
    expect_identical(out$gene$fry$bar, alone2$gene$fry[[1]])
})

test_that("runScreen works with custom design and contrasts", {
    tmp <- tempfile()
    custom <- runScreen(se, design=~0 + group, contrasts="groupB - groupA", gene.field="gene", output.dir=tmp, suppress.plots=TRUE)
    meta <- augere.de::readResult(file.path(tmp, "results", "barcode-1"))$metadata
    expect_identical(meta$differential_barcode_abundance$contrast$type, "custom")
    meta <- augere.de::readResult(file.path(tmp, "results", "simes-1"))$metadata
    expect_identical(meta$differential_gene_abundance$contrast$type, "custom")

    # Making sure we get the same results with a simple design.
    tmp <- tempfile()
    comp <- runScreen(se, group="group", comparisons=c("B", "A"), gene.field="gene", subset.group=FALSE, output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)
    expect_identical(custom$normalized, comp$normalized)
    expect_identical(unname(custom$barcode), unname(comp$barcode))
    expect_identical(unname(custom$gene$fry), unname(comp$gene$fry))
    expect_identical(unname(custom$gene$simes), unname(comp$gene$simes))
})

test_that("runScreen works with duplicateCorrelation", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), dc.block="batch", gene.field="gene", output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)

    fname <- readLines(file.path(tmp, "report.Rmd"))
    expect_true(any(grepl("duplicateCorrelation(", fname, fixed=TRUE)))
    expect_gte(sum(grepl("block=dc.block,", fname, fixed=TRUE)), 3) # remember, it's used in fry() as well. 
})

test_that("runScreen works with no consolidation methods", {
    # Attempt saving to make sure it skips the per-gene results.
    output <- tempfile()
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), consolidation=NULL, gene.field="gene", output.dir=output, suppress.plots=TRUE)
    expect_identical(length(res$gene), 0L)

    lines <- readLines(file.path(output, "report.Rmd"))
    expect_false(any(grepl("by.gene", lines, fixed=TRUE)))
    expect_false(any(grepl("extra.gene.data", lines, fixed=TRUE)))
})

test_that("runScreen works with no summary", {
    output <- tempfile()
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), report.summary=FALSE, gene.field="gene", output.dir=output, suppress.plots=TRUE, save.results=FALSE)
    expect_identical(names(res$gene), c("simes", "fry", "holm-min")) 

    expected.names <- sort(unique(rowData(se)$gene))
    for (meth in res$gene) {
        df <- meth[[1]]
        expect_identical(rownames(df), expected.names)
        expect_null(df$NumUp)
        expect_null(df$NumDown)
        expect_null(df$LogFC)
        expect_type(df$NumBarcodes, "integer")
        expect_type(df$PValue, "double")
        expect_type(df$FDR, "double")
    }
})

test_that("runScreen works with extra gene data", {
    output <- tempfile()
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), gene.data="type", gene.field="gene", output.dir=output, suppress.plots=TRUE, save.results=FALSE)
    expect_identical(names(res$gene), c("simes", "fry", "holm-min")) 

    expected.names <- sort(unique(rowData(se)$gene))
    for (meth in res$gene) {
        df <- meth[[1]]
        expect_identical(rownames(df), expected.names)
        expect_type(df$NumUp, "integer")
        expect_type(df$NumDown, "integer")
        expect_type(df$LogFC, "double")
        expect_type(df$type, "character")
        expect_type(df$NumBarcodes, "integer")
        expect_type(df$PValue, "double")
        expect_type(df$FDR, "double")
    }
})

test_that("runScreen works with extra fry arguments", {
    output <- tempfile()
    res <- runScreen(se, groups="group", comparisons=c("A", "B"), fry.args=list(standardize="none"), consolidation="fry", gene.field="gene", output.dir=output, suppress.plots=TRUE, save.results=FALSE)
    expect_identical(names(res$gene), "fry")
    lines <- readLines(file.path(output, "report.Rmd"))
    expect_true(any(grepl("standardize=\"none\"", lines, fixed=TRUE)))
})

test_that("runScreen works with some of the other voom-related options", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), robust=FALSE, trend=TRUE, quality=FALSE, gene.field="gene", output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)

    fname <- readLines(file.path(tmp, "report.Rmd"))
    expect_false(any(grepl("voomWithQualityWeights(", fname, fixed=TRUE)))
    expect_true(any(grepl("voom(", fname, fixed=TRUE)))
    expect_true(any(grepl("trend=TRUE", fname, fixed=TRUE)))
    expect_false(any(grepl("robust=TRUE", fname, fixed=TRUE)))
})

test_that("runScreen works with dry runs and no saving", {
    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), gene.field="gene", dry.run=TRUE, output.dir=tmp)
    expect_null(out)
    expect_true(file.exists(file.path(tmp, "report.Rmd")))

    tmp <- tempfile()
    out <- runScreen(se, group="group", comparisons=c("C", "A"), gene.field="gene", output.dir=tmp, suppress.plots=TRUE, save.results=FALSE)
    expect_s4_class(out$normalized, "SummarizedExperiment")
    expect_s4_class(out$barcode[[1]], "DFrame")
    expect_s4_class(out$gene$fry[[1]], "DFrame")
    expect_false(file.exists(file.path(tmp, "results")))
})

## ----echo=FALSE, results="hide"-----------------------------------------------
knitr::opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
self <- BiocStyle::Biocpkg("augere.screen")

## -----------------------------------------------------------------------------
make_mock_dataset <- function() {
    set.seed(100)
    mu <- 2^runif(1000, 3, 6)
    grouping <- rep(c("A", "B", "ctrl"), each=3)
    counts <- matrix(rnbinom(length(mu)* length(grouping), mu=mu, size=20), ncol=length(grouping))
    rownames(counts) <- sprintf("BARCODE-%s", seq_along(mu))

    library(SummarizedExperiment)
    se <- SummarizedExperiment(list(counts=counts), colData=DataFrame(group=grouping))
    rowData(se)$type <- "other"
    rowData(se)$gene <- paste0("GENE-", sample(LETTERS, length(mu), replace=TRUE))
    rowData(se)$type[1:50] <- "NEG"
    rowData(se)$gene[1:50] <- "NEG"

    se
}

se <- make_mock_dataset()
se

## ----fig.show="hide"----------------------------------------------------------
library(augere.screen)
output.dir <- tempfile()
res <- runScreen(
    se,
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    output.dir=output.dir
)

# List of tables of barcode-level differential results.
names(res$barcode)
res$barcode[[1]]

# List of tables of gene-level statistics.
names(res$gene)

# Copy of 'se' with normalized abundance values.
res$normalized

## -----------------------------------------------------------------------------
fname <- file.path(output.dir, "report.Rmd")
cat(head(readLines(fname), 50), sep="\n")

## -----------------------------------------------------------------------------
reloaded <- readResult(file.path(output.dir, "results", "barcode-1"))
reloaded$x # the result itself
str(reloaded$metadata) # along with some metadata

## -----------------------------------------------------------------------------
names(res$gene$simes)
res$gene$simes[[1]]

## -----------------------------------------------------------------------------
res$gene$`holm-min`[[1]]

## -----------------------------------------------------------------------------
res$gene$fry[[1]]

## ----echo=FALSE---------------------------------------------------------------
fname <- file.path(output.dir, "report.Rmd")
lines <- readLines(fname)
has.stop <- grep("stop(", lines, fixed=TRUE)[1]
cat(lines[has.stop + (-5):5], sep="\n")

## -----------------------------------------------------------------------------
output.dry.dir <- tempfile()
runScreen(
    wrapInput(se, commands=as.character(body(make_mock_dataset))[-1]),
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    output.dir=output.dry.dir,
    dry.run=TRUE
)

## ----echo=FALSE---------------------------------------------------------------
fname <- file.path(output.dry.dir, "report.Rmd")
lines <- readLines(fname)
has.loader <- grep("set.seed(", lines, fixed=TRUE)[1]
cat(lines[has.loader + (-5):5], sep="\n")

## ----fig.show="hide"----------------------------------------------------------
output.custom.dir <- tempfile()
res <- runScreen(
    se,
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    row.data=c("gene", "type"),
    gene.data="type",
    metadata=list(
        project="my_phd_project",
        collaborators=list("anne", "bob", "charlie"),
        data_source="https://foo.bar.com"
    ),
    output.dir=output.custom.dir
)

# rowData columns are now included in the barcode- and gene-level DFss.
res$barcode[[1]]
res$gene$simes[[1]]

# The custom metadata is also saved to disk.
str(readResult(file.path(output.custom.dir, "results", "barcode-1"))$metadata)

## -----------------------------------------------------------------------------
sessionInfo()

#' @import augere.core
#' @importFrom augere.de processCustomDesignMatrix processCustomContrasts processSimpleDesignMatrix processSimpleComparisons findSubsetGroups
.initialize <- function(
    x,
    method,
    assay,
    groups, 
    comparisons, 
    covariates,
    block,
    subset.factor,
    subset.levels,
    subset.groups,
    design,
    contrasts,
    filter.reference.factor,
    filter.reference.levels,
    filter.num.mads,
    filter.default,
    author
) {
    template <- system.file("templates", "initialize.Rmd", package="augere.screen", mustWork=TRUE)
    parsed <- parseRmdTemplate(readLines(template))

    parsed[["create-se"]] <- processInputCommands(x, name="se")

    replacements <- list(
        METHOD=method,
        ASSAY=deparseToString(assay),
        AUTHOR=paste(sprintf("  - %s", author), collapse="\n")
    )

    #########################################
    ### Sample subsetting, design matrix. ###
    #########################################

    if (!is.null(subset.factor)) {
        parsed[["subset-se"]] <- replacePlaceholders(
            parsed[["subset-se"]],
            list(
                SUBSET_FACTOR=deparseToString(subset.factor),
                SUBSET_LEVELS=deparseToString(subset.levels)
            )
        )
    } else {
        parsed[["subset-se"]] <- NULL
    }

    mds.use.group <- FALSE
    if (!is.null(design) && !is.null(contrasts)) {
        parsed[["design-matrix"]] <- processCustomDesignMatrix(design=design, se.name="se")
        contrast.info <- processCustomContrasts(contrasts)
        replacements$FILTER_OPTS <- "design=design"
        parsed[["subset-group"]] <- NULL

    } else {
        parsed[["design-matrix"]] <- processSimpleDesignMatrix(groups=groups, block=block, covariates=covariates, se.name="se")
        contrast.info <- processSimpleComparisons(comparisons)

        if (is.null(groups)) {
            replacements$FILTER_OPTS <- "design=design"
            parsed[["subset-group"]] <- NULL
        } else {
            replacements$FILTER_OPTS <- "group=model.data$group."
            mds.use.group <- TRUE

            group.levels <- NULL
            if (subset.groups) {
                group.levels <- findSubsetGroups(contrast.info)
            }
            if (!is.null(group.levels)) {
                parsed[["subset-group"]] <- replacePlaceholders(
                    parsed[["subset-group"]],
                    list(
                        GROUP_FACTOR=deparseToString(groups),
                        GROUP_LEVELS=deparseToString(group.levels)
                    )
                )
            } else {
                parsed[["subset-group"]] <- NULL
            }
        }
    }

    #########################
    ### Barcode filtering ###
    #########################

    some.filtering <- FALSE
    if (is.null(filter.reference.factor) || is.null(filter.reference.levels)) {
        parsed[["ref-filtering"]] <- NULL
    } else {
        some.filtering <- TRUE
        parsed[["ref-filtering"]] <- replacePlaceholders(
            parsed[["ref-filtering"]], 
            list(
                REFERENCE_FIELD=deparseToString(filter.reference.factor),
                REFERENCE_LEVELS=deparseToString(filter.reference.levels),
                NUM_MADS=deparseToString(filter.num.mads)
            ),
            error=FALSE
        )
    }

    if (!filter.default) {
        parsed[["filter-default"]] <- NULL
    } else {
        some.filtering <- TRUE
    }
    if (some.filtering) {
        parsed[["filter-none"]] <- NULL
    }

    list(
        text=replacePlaceholders(parsed, replacements),
        contrasts=contrast.info,
        mds.use.group=mds.use.group
    )
}

# library(testthat); library(augere.screen); source("test-initialize.R")

library(SummarizedExperiment)
cd <- DataFrame(group = rep(LETTERS[1:4], each=5), age=1:20, batch=factor(rep(1:5, 4)))
means <- 2^runif(1000, 1, 10)
means[1] <- 0 # to test the filtering.
mat <- matrix(rnbinom(length(means) * nrow(cd), mu=means, size=10), nrow=length(means), ncol=nrow(cd))
se <- SummarizedExperiment(list(counts=mat), colData=cd)

test_that(".initialize() works with 'default' options", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons=c("A", "B"),
        covariates=NULL,
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=TRUE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    # Checking that the contrasts are okay.
    expect_identical(output$contrasts[[1]]$title, "Increase in `A` over `B`")
    expect_identical(output$contrasts[[1]]$type, "versus")
    expect_identical(output$contrasts[[1]]$left, list("A"))
    expect_identical(output$contrasts[[1]]$right, list("B"))
    expect_true(output$mds.use.group)

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)

    expect_identical(env$se, se[,se$group %in% c("A", "B")])
    expect_identical(colnames(env$design), c("group.A", "group.B"))

    expect_true(inherits(env$y, "DGEList"))
    expect_type(env$y$genes$origin, "integer") 
    expect_lt(nrow(env$y), nrow(se))
    expect_false(1 %in% env$y$genes$origin) 

    all.text <- unlist(output$text)
    expect_true(any(grepl("filterByExpr\\(.*group=", all.text)))
    expect_false(any(grepl("omit the filtering", all.text)))
})

test_that(".initialize() works with no filtering by group", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons=c("A", "B"),
        covariates=NULL,
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=FALSE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)

    expect_identical(env$se, se)
})

test_that(".initialize() works with custom sample filtering", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons=c("A", "B"),
        covariates=NULL,
        block="batch",
        subset.factor="batch",
        subset.levels=c(2,4),
        subset.groups=TRUE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)

    expect_identical(env$se, se[,se$group %in% c("A", "B") & se$batch %in% c(2, 4)])
})

test_that(".initialize() works for a design matrix without groups", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups=NULL,
        comparisons=c("age"),
        covariates="age",
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=TRUE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    expect_false(output$mds.use.group)

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)
    expect_identical(env$se, se) # no filtering is done on the samples.
    expect_true(any(grepl("filterByExpr\\(.*design=", unlist(output$text))))
})

test_that(".initialize() works with covariates + group but only the covariates are tested", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons="age",
        covariates="age",
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=FALSE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    expect_true(output$mds.use.group)

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)
    expect_identical(env$se, se) # no filtering by sample.
    expect_true(any(grepl("filterByExpr\\(.*group=", unlist(output$text))))
})

test_that(".initialize() works with custom matrices and contrasts", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=TRUE,
        design=~group + batch,
        contrasts="groupC - groupD",
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=TRUE,
        author="Chihaya Kisaragi"
    )

    expect_false(output$mds.use.group)

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)
    expect_identical(env$se, se) # no filtering is done on the samples.
    expect_true(any(grepl("filterByExpr\\(.*design=", unlist(output$text))))

    # Checking that the contrasts are okay.
    expect_identical(output$contrasts[[1]]$type, "custom")
})

test_that(".initialize() works with reference-based filtering", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons=c("B", "A"),
        covariates=NULL,
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=TRUE,
        design=NULL,
        contrasts=NULL,
        # Works when the reference samples aren't even part of the object anymore.
        filter.reference.factor="group",
        filter.reference.levels=c("C", "D"),
        filter.num.mads=0.1,
        filter.default=FALSE,
        author="Chihaya Kisaragi"
    )

    all.text <- unlist(output$text)
    expect_false(any(grepl("omit the filtering", all.text)))
    expect_false(any(grepl("filterByExpr", all.text))) # still have the default filtering enabled as well.

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)
    expect_identical(sort(unique(env$se$group)), c("A", "B"))
    expect_lt(nrow(env$y), nrow(se))

    expect_type(env$ref.non.empty, "integer")
    expect_false(1 %in% env$ref.non.empty)
    expect_type(env$ref.filtered, "logical")
    expect_false(env$ref.filtered[1])
    expect_gt(env$ref.med.ab, env$ref.threshold)
    expect_false(identical(env$filtered, env$ref.filtered))
    expect_false(1 %in% env$y$genes$origin)
})

test_that(".initialize() works with no filtering", {
    fun <- augere.core::resetInputCache()
    on.exit(fun(), add=TRUE, after=TRUE)

    output <- augere.screen:::.initialize(
        x=se, 
        method="edgeR",
        assay="counts",
        groups="group",
        comparisons=c("B", "A"),
        covariates=NULL,
        block=NULL,
        subset.factor=NULL,
        subset.levels=NULL,
        subset.groups=TRUE,
        design=NULL,
        contrasts=NULL,
        filter.reference.factor=NULL,
        filter.reference.levels=NULL,
        filter.num.mads=3,
        filter.default=FALSE,
        author="Chihaya Kisaragi"
    )

    all.text <- unlist(output$text)
    expect_true(any(grepl("omit the filtering", all.text)))
    expect_false(any(grepl("med.ab", all.text)))
    expect_false(any(grepl("filterByExpr", all.text)))

    env <- new.env()
    tmp <- tempfile()
    dir.create(tmp)
    augere.core::compileReport(file=file.path(tmp, "report.Rmd"), contents=output$text, env=env)
    expect_identical(nrow(env$y), nrow(se))
    expect_true(1 %in% env$y$genes$origin)
})

# Dimensionality reduction

To get an overview of our dataset, we create a multi-dimensional scaling (MDS) plot.
Samples that are closer together on the plot are more similar in their expression profiles -
or more specifically, the most extreme log-fold changes are closer to zero.

:BEGIN mds-grouped
```{r plot-mds, fig.cap="MDS plot of the dataset. Each point represents a sample and is named/colored according to its group(s) of origin."}
mds.labels <- factor(model.data$group.)
limma::plotMDS(y.cpm, labels=as.character(mds.labels), col=as.integer(mds.labels))
```
:END
:BEGIN mds-ungrouped
```{r plot-mds, fig.cap="MDS plot of the dataset. Each point represents a sample."}
limma::plotMDS(y.cpm)
```
:END

# Model fitting

voom uses the empirical mean-variance trend to compute a weight for each observation. 
In this manner, log-CPMs derived from low counts are downweighted to reflect their lower precision.
:BEGIN quality-text
We estimate sample-specific quality weights to reduce the impact of outlier replicates without resorting to their removal.
:END
:BEGIN duplicate-correlation
We use `duplicateCorrelation()` to account for correlations between samples with the same level of blocking factor.

```{r duplicate-correlation, fig.wide=TRUE}
library(limma)
dc.block <- factor(SummarizedExperiment::colData(se)[[<%= DUPCOR_BLOCK %>]])

# Iteratively refine the precision weights after estimating the correlation. 
v <- limma::<%= VOOM_CMD %>(y, design=design, plot=FALSE)
dc <- limma::duplicateCorrelation(v, design=design, block=dc.block)
v <- limma::<%= VOOM_CMD %>(y, design=design, plot=TRUE, block=dc.block, 
    correlation=dc$consensus.correlation)
dc <- limma::duplicateCorrelation(v, design=design, block=dc.block)

dc$consensus.correlation
```
:END

:BEGIN voom
```{r voom}
library(limma)
v <- limma::<%= VOOM_CMD %>(y, design=design, plot=TRUE)
```
:END

Once the precision weights are computed, we fit the linear model for each barcode. 

```{r}
# 'v' stores 'design' so we don't need to explicitly pass it.
fit <- limma::lmFit(v<%= LM_OPTS %>)
```

Empirical Bayes shrinkage shares information across barcodes to stabilize the variance estimates.
The estimated prior degrees of freedom (d.f.) represents the variability of the variances across barcodes, typically ranging from 5 to 20.
Large values indicate that the variances were consistent across features, allowing us to perform more aggressive shrinkage for greater power.
:BEGIN robust-text
We enable robustification to ensure that highly variable barcodes (or very small variances at discrete low counts) do not deflate the prior degrees of freedom.
:END

```{r}
fit <- limma::eBayes(fit<%= EB_OPTS %>)
summary(fit$df.prior)
```

We examine the mean-variance relationship for the shrunk estimates.
Ideally, there should be no trend at all as it should have been handled by the observation weights.

```{r plot-sa, fig.cap="Residual standard deviation (sigma) plotted against the mean log-CPM. Each point represents a barcode<%= EXTRA_EB_CAPT %>."}
limma::plotSA(fit)
```

# Performing contrasts

## Setup 

We define a list to hold the barcode-result from each contrast.

```{r}
all.barcodes <- list()
```

We create a directory in which to save the results to disk.

```{r save-directory}
result.dir <- "results"
dir.create(result.dir)
```

:BEGIN gene-output
Setting up lists to hold results at the gene level:

```{r}
:BEGIN init-simes
all.simes <- list()
:END
:BEGIN init-holm-min
all.holm.min <- list()
:END
:BEGIN init-fry
all.fry <- list()
:END
```

Also defining some common variables for gene-level consolidation.

```{r}
gene.ids <- SummarizedExperiment::rowData(se)[[<%= GENE_FIELD %>]]
all.genes <- sort(unique(gene.ids))
:BEGIN create-summary-indices

# Creating gene set indices to summarize barcode results per gene. 
by.gene <- split(seq_along(gene.ids), factor(gene.ids, all.genes))
:END
:BEGIN create-fry-indices

# Creating gene set indices after filtering, for use in fry.
by.gene.filtered <- split(seq_along(v$genes$origin), gene.ids[v$genes$origin])
:END
:BEGIN create-gene-annotation

# Extracting some gene-level data to store in each DataFrame.
extra.gene.data <- SummarizedExperiment::rowData(se)[match(all.genes, gene.ids),<%= GENE_DATA_FIELDS %>,drop=FALSE]
rownames(extra.gene.data) <- all.genes
:END
```
:END

:BEGIN create-common-metadata
We also set up some extra metadata to add to each result.

```{r}
common.meta <- <%= COMMON_METADATA %>
```
:END

:BEGIN contrast

## <%= CONTRAST_NAME_SIMPLE %>

### Testing each barcode

We set up the contrast, a vector specifying the null hypothesis in terms of the design matrix's coefficients.
(This may also be a matrix where the joint null is defined from the hypotheses for the individual columns.)

```{r}
:BEGIN contrast-command
:END
con
```

:BEGIN lfc-contrast
For single contrasts, we can focus on barcodes with larger effect sizes by using `treat()` to test for significant differences from a log-fold change threshold.

```{r}
fit2 <- limma::contrasts.fit(fit, con)
fit2 <- limma::treat(fit2, lfc=<%= LFC_THRESHOLD %><%= EB_OPTS %>)
```
:END

:BEGIN no-lfc-contrast
We perform moderated $t$-tests to identify significant deviations from the null hypothesis.

```{r}
fit2 <- limma::contrasts.fit(fit, con)
fit2 <- limma::eBayes(fit2<%= EB_OPTS %>)
```
:END

We retrieve a table of per-barcode DE statistics:

```{r}
tab <- limma::topTable(fit2, n=Inf, sort.by="none")
tab[head(order(tab$P.Value)),]
```

We report summary statistics for this comparison, defining significant differences at a FDR threshold of 5%.

```{r, eval=is.null(dim(con)), echo=is.null(dim(con))}
summary(limma::decideTests(fit2))
```

```{r, eval=!is.null(dim(con)), echo=!is.null(dim(con))}
summary(tab$FDR <= 0.05)
```

Now making some diagnostic plots.

```{r plot-md-<%= CONTRAST_INDEX %>, fig.cap='Mean-difference plot for this contrast. Each point represents a gene and is colored according to whether it was significantly up- or down-regulated at an FDR of 5%.', eval=is.null(dim(con)), echo=is.null(dim(con))}
limma::plotMD(fit2, status=limma::decideTests(fit2), hl.cex=0.5)
```

```{r plot-volcano-<%= CONTRAST_INDEX %>, fig.cap='Volcano plot for this contrast. Each point represents a barcode, colored according to whether it was significantly up- or down-regulated at an FDR of 5%. The dotted line represents the effective $p$-value threshold for significance.', eval=is.null(dim(con)), echo=is.null(dim(con))}
limma::volcanoplot(fit2)
is.de <- tab$FDR <= 0.05
if (any(is.de, na.rm=TRUE)) {
    eff.thresh <- max(tab$PValue[is.de], na.rm=TRUE)
    abline(h=-log10(eff.thresh), lty=2, col='red')
}
```

We expand the result table to restore the full set of rows in our original `SummarizedExperiment`.
Low-abundance barcodes are assigned `NA` statistics, to distinguish them from barcodes that were not present in the annotation at all.

```{r}
barcode.df <- S4Vectors::DataFrame(tab)
barcode.df <- barcode.df[match(seq_len(nrow(se)), barcode.df$origin),]
rownames(barcode.df) <- rownames(se)
barcode.df$origin <- NULL
:BEGIN attach-rowdata
barcode.df <- cbind(SummarizedExperiment::rowData(se)[,<%= ROWDATA_FIELDS %>,drop=FALSE], barcode.df)
:END
```

We also give nicer names to some of the columns: 

```{r}
colnames(barcode.df)[colnames(barcode.df) == "AveExpr"] <- "AveAb"
colnames(barcode.df)[colnames(barcode.df) == "P.Value"] <- "PValue"
colnames(barcode.df)[colnames(barcode.df) == "adj.P.Val"] <- "FDR"
```

```{r, eval=is.null(dim(con)), echo=is.null(dim(con))}
colnames(barcode.df)[colnames(barcode.df) == "logFC"] <- "LogFC"
```

```{r, eval=!is.null(dim(con)), echo=!is.null(dim(con))}
expected <- make.names(colnames(con))
m <- match(expected, colnames(barcode.df))
stopifnot(!anyNA(m), !anyDuplicated(m))
colnames(barcode.df)[m] <- paste0("LogFC.", colnames(con))
```

We store the results in our output list.

```{r}
all.barcodes[[<%= CONTRAST_NAME_DEPARSED %>]] <- barcode.df
```

We also save them to file with some metadata describing what's going on.

```{r <%= SAVING_CHUNK_NAME %>}
barcode.meta <- list(
    title=paste(<%= CONTRAST_NAME_DEPARSED %>, "(barcode)"),
    authors=<%= AUTHOR %>,
    type="differential_barcode_abundance",
    differential_barcode_abundance=list(
:BEGIN diff-metadata
:END
:BEGIN subset-metadata
        subset=subset.meta,
:END
        normalization=norm.meta,
        method="voom-limma"
    )
)

augere.core::saveResult(
    barcode.df,
    file.path(result.dir, paste0("barcode-", length(all.barcodes))),
:BEGIN merge-metadata
    metadata=c(common.meta, barcode.meta)
:END
:BEGIN no-merge-metadata
    metadata=barcode.meta
:END
)
```

:BEGIN create-summary
We compute some statistics to summarize the barcode results for each gene.
These will be stored alongside the consolidated gene-level results to assist interpretation.

```{r}
barcode.summaries <- <%= SUMMARY_CMDS %>
stopifnot(identical(rownames(barcode.summaries), all.genes))
```
:END

:BEGIN simes
### Consolidation with Simes 

We consolidate the barcode-level statistics into gene-level results using Simes' method.
Here, the null hypothesis is that all barcodes for a gene are not differentially abundant.
This is the most sensitive consolidation method as it can be rejected if any barcode is sufficiently significant.

```{r}
simes.res <- <%= SIMES_CMD %>
simes.res <- simes.res[match(all.genes, rownames(simes.res)),,drop=FALSE]
rownames(simes.res) <- all.genes
:BEGIN gene-annotation
simes.res <- cbind(extra.gene.data, simes.res)
:END
:BEGIN barcode-summaries
simes.res <- cbind(simes.res, barcode.summaries)
:END
```

We look at the top genes: 

```{r}
head(simes.res[order(simes.res$PValue),])
```

We look at the number of significant genes: 

```{r, eval=is.null(dim(con)), echo=is.null(dim(con))}
table(Significant=simes.res$FDR <= 0.05, Direction=simes.res$Direction)
```

```{r, eval=!is.null(dim(con)), echo=!is.null(dim(con))}
table(Significant=holm.res$FDR <= 0.05)
```

We add it into our list of results.

```{r}
all.simes[[<%= CONTRAST_NAME_DEPARSED %>]] <- simes.res
```

We also save them to file with some metadata. 

```{r <%= SAVING_CHUNK_NAME %>}
simes.meta <- list(
    title=paste(<%= CONTRAST_NAME_DEPARSED %>, "(Simes)"),
    authors=<%= AUTHOR %>,
    type="differential_gene_abundance",
    differential_gene_abundance=list(
:BEGIN diff-metadata
:END 
:BEGIN subset-metadata
        subset=subset.meta,
:END
        normalization=norm.meta,
        method="simes"
    )
)

augere.core::saveResult(
    simes.res, 
    file.path(result.dir, paste0("simes-", length(all.simes))),
:BEGIN merge-metadata
    metadata=c(common.meta, simes.meta)
:END
:BEGIN no-merge-metadata
    metadata=simes.meta
:END
)
```
:END

:BEGIN fry
### Consolidation with `fry`

We consolidate barcode-level statistics into gene-level results using the `fry` method.
This re-uses `r BiocStyle::Biocpkg("limma")`'s tests to perform a self-contained "barcode set".
Here, the null hypothesis is that no barcodes for a given gene are differentially abundant,
though a low `fry` $p$-value typically requires a significant change in most barcodes for a gene.

```{r}
fry.res <- limma::fry(
    v,
    index=by.gene.filtered,
    design=design,
    contrast=con,
    sort="none"<%= FRY_OPTS %>
)
fry.res <- S4Vectors::DataFrame(fry.res)
colnames(fry.res)[colnames(fry.res) == "NGenes"] <- "NumBarcodes"
fry.res$Direction <- tolower(fry.res$Direction)
stopifnot(identical(rownames(fry.res), names(by.gene.filtered)))

fry.res <- fry.res[match(all.genes, rownames(fry.res)),,drop=FALSE]
rownames(fry.res) <- all.genes
fry.res$NumBarcodes[is.na(fry.res$NumBarcodes)] <- 0L
:BEGIN gene-annotation
fry.res <- cbind(extra.gene.data, fry.res)
:END
:BEGIN barcode-summaries
fry.res <- cbind(fry.res, barcode.summaries)
:END
```

We look at the top features after consolidation.

```{r}
head(fry.res[order(fry.res$PValue),])
```

We look at the number of significant genes in each direction:

```{r}
table(Significant=fry.res$FDR <= 0.05, Direction=fry.res$Direction)
```

We then save it into our list of results.

```{r}
all.fry[[<%= CONTRAST_NAME_DEPARSED %>]] <- fry.res
```

We also save them to file with some metadata. 

```{r <%= SAVING_CHUNK_NAME %>}
fry.meta <- list(
    title=paste(<%= CONTRAST_NAME_DEPARSED %>, "(fry)"),
    authors=<%= AUTHOR %>,
    type="differential_gene_abundance",
    differential_gene_abundance=list(
:BEGIN diff-metadata
:END 
:BEGIN subset-metadata
        subset=subset.meta,
:END
        normalization=norm.meta,
        method="fry"
    )
)

augere.core::saveResult(
    fry.res, 
    file.path(result.dir, paste0("fry-", length(all.fry))),
:BEGIN merge-metadata
    metadata=c(common.meta, fry.meta)
:END
:BEGIN no-merge-metadata
    metadata=fry.meta
:END
)
```
:END

:BEGIN holm-min
### Consolidation with Holm

The "minimum Holm" method tests the null hypothesis that fewer than $k$ barcodes for a gene are differentially abundant.
$k$ is defined as the larger of some minimum value and a proportion of the total number of barcodes for a gene.
This guarantees that some proportion of barcodes is significant for each gene.

```{r}
holm.res <- <%= HOLM_CMD %>
holm.res <- holm.res[match(all.genes, rownames(holm.res)),,drop=FALSE]
rownames(holm.res) <- all.genes
:BEGIN gene-annotation
holm.res <- cbind(extra.gene.data, holm.res)
:END
:BEGIN barcode-summaries
holm.res <- cbind(holm.res, barcode.summaries)
:END
```

We look at the top features after consolidation.

```{r}
head(holm.res[order(holm.res$PValue),])
```

We look at the number of significant genes: 

```{r, eval=is.null(dim(con)), echo=is.null(dim(con))}
table(Significant=holm.res$FDR <= 0.05, Direction=holm.res$Direction)
```

```{r, eval=!is.null(dim(con)), echo=!is.null(dim(con))}
table(Significant=holm.res$FDR <= 0.05)
```

We then save it into our list of results.

```{r}
all.holm.min[[<%= CONTRAST_NAME_DEPARSED %>]] <- holm.res
```

We also save them to file with some metadata. 

```{r <%= SAVING_CHUNK_NAME %>}
holm.meta <- list(
    title=paste(<%= CONTRAST_NAME_DEPARSED %>, "(Holm)"),
    authors=<%= AUTHOR %>,
    type="differential_gene_abundance",
    differential_gene_abundance=list(
:BEGIN diff-metadata
:END 
:BEGIN subset-metadata
        subset=subset.meta,
:END
        normalization=norm.meta,
        method="holm-min"
    )
)

augere.core::saveResult(
    holm.res, 
    file.path(result.dir, paste0("holm-min-", length(all.holm.min))),
:BEGIN merge-metadata
    metadata=c(common.meta, holm.meta)
:END
:BEGIN no-merge-metadata
    metadata=holm.meta
:END
)
```
:END

:END

# Computing normalized values

We create a `SummarizedExperiment` that contains the log-normalized expression values.
This is useful for visualizing the expression profiles of the barcodes of interest.

```{r}
normalized <- se
SummarizedExperiment::rowData(normalized)$retained <- seq_len(nrow(normalized)) %in% y$genes$origin
normalized$lib.size <- y$samples$lib.size
normalized$norm.factors <- y$samples$norm.factors

counts <- SummarizedExperiment::assay(normalized, <%= ASSAY %>)
sf <- normalized$lib.size * normalized$norm.factors
sf <- sf/mean(sf)
SummarizedExperiment::assay(normalized, "logcounts") <- log1p(t(t(counts) / sf))
```

And we save it.

```{r save-norm}
norm.meta <- list(
    title='Normalized barcode data',
    authors=<%= AUTHOR %>,
    type="summarized_experiment",
    summarized_experiment=list(
:BEGIN subset-metadata
        subset=subset.meta,
:END
        normalization=norm.meta
    )
)

augere.core::saveResult(
    normalized,
    file.path(result.dir, "normalized"), 
:BEGIN merge-metadata
    metadata=c(common.meta, norm.meta)
:END
:BEGIN no-merge-metadata
    metadata=norm.meta
:END
)
```

# Session information {-}

```{r}
sessionInfo()
```

---
title: Differential barcode abundance for functional screens
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
- name: Jean-Philippe Fortin
date: "Revised: November 24, 2025"  
output: BiocStyle::html_document
package: augere.screen
vignette: >
  %\VignetteIndexEntry{Differential abundance for functional screens}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE, results="hide"}
knitr::opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
self <- BiocStyle::Biocpkg("augere.screen")
```

# Overview

`r self` implements an [**augere** pipeline](https://github.com/augere-bioinfo) to detect differentially abundant barcodes in a functional screen.
Given a matrix of barcode-by-sample counts, this uses `voom()` from the `r BiocStyle::Biocpkg("limma")` package to test for differences between conditions.
It then consolidates barcode-level statistics into per-gene inferences with a variety of statistical methods.
The pipeline also creates a self-contained Rmarkdown report that documents each step in the analysis.

# Quick start

To install this package, follow the usual [instructions for Bioconductor](https://bioconductor.org/install):

```r
install.packages("BiocManager") # if not already available
BiocManager::install("augere.screen")
```

Now let's mock up a dataset from a functional screen.
This contains a count matrix of barcode abundances, where each row is a barcode and each column is a sample.
Each barcode is associated to a target gene via a 1:many mapping.
Some barcodes are also negative controls, i.e., they do not target any gene.

```{r}
make_mock_dataset <- function() {
    set.seed(100)
    mu <- 2^runif(1000, 3, 6)
    grouping <- rep(c("A", "B", "ctrl"), each=3)
    counts <- matrix(rnbinom(length(mu)* length(grouping), mu=mu, size=20), ncol=length(grouping))
    rownames(counts) <- sprintf("BARCODE-%s", seq_along(mu))

    library(SummarizedExperiment)
    se <- SummarizedExperiment(list(counts=counts), colData=DataFrame(group=grouping))
    rowData(se)$type <- "other"
    rowData(se)$gene <- paste0("GENE-", sample(LETTERS, length(mu), replace=TRUE))
    rowData(se)$type[1:50] <- "NEG"
    rowData(se)$gene[1:50] <- "NEG"

    se
}

se <- make_mock_dataset()
se
```

The `runScreen()` function uses `voom()` to test for differential abundance across a comparison of interest.
Let's say we want to compare `A` versus `B`:

```{r, fig.show="hide"}
library(augere.screen)
output.dir <- tempfile()
res <- runScreen(
    se,
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    output.dir=output.dir
)

# List of tables of barcode-level differential results.
names(res$barcode)
res$barcode[[1]]

# List of tables of gene-level statistics.
names(res$gene)

# Copy of 'se' with normalized abundance values.
res$normalized
```

The function generates an Rmarkdown report containing (almost) all of the steps required to reproduce the analysis.
Let's have a look at it:

```{r}
fname <- file.path(output.dir, "report.Rmd")
cat(head(readLines(fname), 50), sep="\n")
```

The function will also save the results to file inside a `results` subdirectory, which can be loaded back into the session using the `readResult()` function:

```{r}
reloaded <- readResult(file.path(output.dir, "results", "barcode-1"))
reloaded$x # the result itself
str(reloaded$metadata) # along with some metadata
```

# Explaining parameters 

As one might expect, the `group` and `comparisons` arguments specify to the grouping factor in `colData(se)` and the comparison(s) to be performed, respectively.
Many of the arguments to `runScreen()` are shared with those in the `runVoom()` function in the `r BiocStyle::Biocpkg("augere.de")` package for differential expression,
so readers are referred to the latter's vignette for more details on the parametrization of the design and contrasts.

The `gene.field` argument specifies the column of `rowData(se)` that defines the gene associated with each barcode.
This is used to consolidate the barcode-level statistics into per-gene results.
Doing so is usually desirable as genes are the features of scientific interest, not barcodes.
If this argument is not supplied, no consolidation is performed.

The `filter.reference.factor` and `filter.reference.levels` arguments specify the reference samples in the dataset.
These are used to quantify the abundances in the original barcode library.
We then remove barcodes with unusually low abundances in the references, e.g., due to defects in library manufacture.
If no reference samples are available, `runScreen()` will still use the default filtering from `r BiocStyle::Biocpkg("edgeR")` to remove low-abundance barcodes.

The `norm.control.type.field` and `norm.control.types` arguments specify the control barcodes that should not change in abundance during the experiment.
Thus, any differences in abundance are technical and can be used to quantify the scaling bias for normalization.
In this case, our negative controls are marked as targeting `NEG`s, i.e., non-essential genes, though one could also use non-targeting controls (NTC).
If no control barcodes are present, `runScreen()` will fall back to TMM normalization on all barcodes, assuming that the majority of barcodes do not change between conditions.

# Gene-level statistics 

When consolidating barcode-level information into gene-level results,
the joint null hypothesis for each gene is that none of its barcodes are differentially abundant.
Different methods are used by `runScreen()` to test this joint null, each of which has different statistical properties.

The simplest approach involves applying Simes' method to the per-barcode $p$-values.
This is the most sensitive approach as it can reject the joint null if a small number of barcodes (possibly just 1) are differentially abundant.
It is most suited for CRISPRa where few guides are expected to succeed for each gene,
and is also useful for studying sporadic off-target effects in CRISPR knockout or CRISPRi.

```{r}
names(res$gene$simes)
res$gene$simes[[1]]
```

A more stringent approach uses an adaptation of the Holm method on the per-barcode $p$-values.
This only rejects the joint null if a user-specified minimum number/proportion of barcodes for a gene are differentially abundant. 
It is suitable for all CRISPR modalities but tends to be more conservative than the other methods.

```{r}
res$gene$`holm-min`[[1]]
```

Finally, we can use the `fry()` method from `r BiocStyle::Biocpkg("limma")` to perform a "barcode set test" on the barcode abundances for each gene.
This favors consistent differences across the majority of barcodes for a given gene.
It is most suited to CRISPR knockout or CRISPRi screens.

```{r}
res$gene$fry[[1]]
```

For each gene, we also report the number of barcodes changing in each direction, the net direction of change, and the average abundance and log-fold change of the most significant barcode.
This can be helpful for interpreting the gene's consolidated statistics.

# More output options

We can set `save.results=FALSE` to instruct `runEdgeR()` to not write results to disk.
This is more efficient if we only need the results in the current R session.

Setting `dry.run=TRUE` will instruct `runEdgeR()` to only generate the Rmarkdown report but not evaluate it.
This can be helpful for generating a draft report for further refinement.

Careful readers might notice that the Rmarkdown report generated by `runScreen()` is not quite self-contained as the pipeline doesn't know how `se` was constructed.
In the absence of this information, the report contains a placeholder `stop()` to remind the user to insert the relevant commands:

```{r, echo=FALSE}
fname <- file.path(output.dir, "report.Rmd")
lines <- readLines(fname)
has.stop <- grep("stop(", lines, fixed=TRUE)[1]
cat(lines[has.stop + (-5):5], sep="\n")
```

If we know how the object was generated, we can pass this information to `runScreen()`:

```{r}
output.dry.dir <- tempfile()
runScreen(
    wrapInput(se, commands=as.character(body(make_mock_dataset))[-1]),
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    output.dir=output.dry.dir,
    dry.run=TRUE
)
```

This instructs `runScreen()` to insert the relevant commands into the report for full reproducibility:

```{r, echo=FALSE}
fname <- file.path(output.dry.dir, "report.Rmd")
lines <- readLines(fname)
has.loader <- grep("set.seed(", lines, fixed=TRUE)[1]
cat(lines[has.loader + (-5):5], sep="\n")
```

We can also attach `rowData()` columns to the result tables or add custom fields to the result metadata:

```{r, fig.show="hide"}
output.custom.dir <- tempfile()
res <- runScreen(
    se,
    group="group",
    comparison=c("A", "B"),
    gene.field="gene",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    norm.control.type.field="type",
    norm.control.types="NEG",
    row.data=c("gene", "type"),
    gene.data="type",
    metadata=list(
        project="my_phd_project",
        collaborators=list("anne", "bob", "charlie"),
        data_source="https://foo.bar.com"
    ),
    output.dir=output.custom.dir
)

# rowData columns are now included in the barcode- and gene-level DFss.
res$barcode[[1]]
res$gene$simes[[1]]

# The custom metadata is also saved to disk.
str(readResult(file.path(output.custom.dir, "results", "barcode-1"))$metadata)
```

# Session information {-}

```{r}
sessionInfo()
```

# Normalization

:BEGIN norm-control
We use control barcodes that should not change in abundance between samples.
Either they are non-targeting controls or they target genes that are not involved in survival/proliferation.

```{r}
use.for.norm <- logical(nrow(y))
norm.features <- character(0)
```

:BEGIN barcodes
We add a pre-defined set of control barcodes:

```{r}
norm.barcodes <- <%= NORM_BARCODES %>
use.for.norm.barcodes <- rownames(y) %in% unlist(norm.barcodes)
summary(use.for.norm.barcodes)
use.for.norm[use.for.norm.barcodes] <- TRUE
norm.features <- c(norm.features, names(norm.barcodes))
```
:END

:BEGIN genes
We add a pre-defined set of control genes:

```{r}
norm.genes <- <%= NORM_GENES %>
use.for.norm.genes <- SummarizedExperiment::rowData(se)[y$genes$origin, <%= NORM_GENE_FIELD %>] %in% unlist(norm.genes)
summary(use.for.norm.genes)
use.for.norm[use.for.norm.genes] <- TRUE 
norm.features <- c(norm.features, names(norm.genes))
```
:END

:BEGIN types
We add control barcodes based on the row annotation in the `SummarizedExperiment`:

```{r}
norm.types <- <%= NORM_TYPES %>
use.for.norm.types <- SummarizedExperiment::rowData(se)[y$genes$origin, <%= NORM_TYPE_FIELD %>] %in% norm.types
summary(use.for.norm.types)
use.for.norm[use.for.norm.types] <- TRUE
norm.features <- c(norm.features, norm.types)
```
:END

We look at the total number of control barcodes:

```{r}
stopifnot(any(use.for.norm)) # make sure we have at least some controls.
norm.features <- paste(norm.features, collapse=', ')
summary(use.for.norm)
```

:BEGIN tmm
We define a normalization factor for each sample with the TMM method across all control barcodes.
This avoids composition biases due to genuine changes in abundance for barcodes with inadvertent biological activity. 

```{r, fig.wide=TRUE}
ysub <- edgeR::calcNormFactors(y[use.for.norm,,keep.lib.sizes=TRUE])
y$samples$norm.factors <- ysub$samples$norm.factors
norm.meta <- paste0('TMM on controls (', norm.features, ')')
head(y$samples)

par(mfrow=c(1,2))
hist(y$samples$lib.size)
hist(y$samples$norm.factors)
```
:END

:BEGIN lib
We define a normalization factor for each sample based on the sequencing depth (i.e., total counts) across all control barcodes.
Normalization factors are scaled to have a geometric mean of 1 to preserve the scale of the library sizes. 

```{r, fig.wide=TRUE}
ratio <- colSums(y$counts[use.for.norm,,drop=FALSE])/y$samples$lib.size
y$samples$norm.factors <- ratio/exp(mean(log(ratio)))
norm.meta <- paste0('library size on controls (', norm.features, ')')
head(y$samples)

par(mfrow=c(1,2))
hist(y$samples$lib.size)
hist(y$samples$norm.factors)
```
:END 

We inspect the normalization results by creating MD (mean-difference) plots.
Ideally, the log-fold changes for most control barcodes should be centered around zero if the normalization was successful.

```{r plot-md-norm, fig.wide=TRUE, fig.asp=1/3, fig.cap="Mean-difference plots for each sample against the average reference of all other samples. Each plot corresponds to a sample while each point represents a barcode, with control barcodes highlighted in red."}
y.cpm <- edgeR::cpm(y, log=TRUE, prior.count=3)

# Avoid creating too many plots, otherwise the compiled report is too big.
par(mfrow=c(1, 3), mar=c(5.1, 4.1, 4.1, 0.1))
for (i in seq_len(min(9, ncol(y.cpm)))) {
    limma::plotMD(y.cpm, column=i, status=as.integer(use.for.norm))
    abline(h=0, col='red', lty=2)
}
```
:END

:BEGIN norm-all
:BEGIN tmm
We define a normalization factor for each sample with the TMM method across all barcodes.
This avoids composition biases due to genuine changes in abundance for barcodes associated with relevant biological processes.

```{r, fig.wide=TRUE}
ysub <- edgeR::calcNormFactors(y)
y$samples$norm.factors <- ysub$samples$norm.factors
norm.meta <- "TMM on all barcodes"
head(y$samples)

par(mfrow=c(1,2))
hist(y$samples$lib.size)
hist(y$samples$norm.factors)
```
:END

:BEGIN lib
We perform library size normalization across all barcodes.

```{r, fig.wide=TRUE}
y$samples$norm.factors <- rep(1, nrow(y$samples))
norm.meta <- "library size on all barcodes"
head(y$samples)

par(mfrow=c(1,2))
hist(y$samples$lib.size)
hist(y$samples$norm.factors)
```
:END

We inspect the normalization results by creating MD (mean-difference) plots.
Ideally, the log-fold changes for most barcodes should be centered around zero if the normalization was successful.

```{r plot-md-norm, fig.wide=TRUE, fig.asp=1/3, fig.cap="Mean-difference plots for each sample against the average reference of all other samples. Each plot corresponds to a sample while each point represents a barcode."}
y.cpm <- edgeR::cpm(y, log=TRUE, prior.count=3)

# Avoid creating too many plots, otherwise the compiled report is too big.
par(mfrow=c(1, 3), mar=c(5.1, 4.1, 4.1, 0.1))
for (i in seq_len(min(9, ncol(y.cpm)))) {
    limma::plotMD(y.cpm, column=i)
    abline(h=0, col='red', lty=2)
}
```
:END

---
title: Differential abundance analysis of functional screens
author:
<%= AUTHOR %>
date: "`r Sys.Date()`"
output: BiocStyle::html_document
---

```{r, echo=FALSE}
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Data loading

Our `SummarizedExperiment` object contains all experimental data and metadata for this study.
Each row corresponds to a barcode while each column corresponds to a sample.

```{r} 
:BEGIN create-se
:END
original <- se # making a copy for downstream use.
se
```

:BEGIN subset-se
We subset the `SummarizedExperiment` to the desired levels of a factor of interest.

```{r}
sub.factor <- <%= SUBSET_FACTOR %>
sub.levels <- <%= SUBSET_LEVELS %>
se <- se[,SummarizedExperiment::colData(se)[,sub.factor] %in% sub.levels]
subset.meta <- sprintf("%s IN (%s)", sub.factor, paste(sub.levels, collapse=","))
ncol(se)
```
:END

:BEGIN subset-group
We subset the `SummarizedExperiment` to the groups involved in the comparison.
This ensures that our variance estimates are not affected by irrelevant variability in other groups.

```{r}
se <- se[,SummarizedExperiment::colData(se)[,<%= GROUP_FACTOR %>] %in% <%= GROUP_LEVELS %>]
ncol(se)
```
:END

We extract the information into a `DGEList` object in preparation for analysis.

```{r}
y <- edgeR::DGEList(SummarizedExperiment::assay(se, <%= ASSAY %>))

# Also tracking the original row index from the SummarizedExperiment,
# so that we can match them up after filtering out low-abundance barcodes.
y$genes <- data.frame(origin=seq_len(nrow(se)))
```

Finally, we build the design matrix.

```{r}
:BEGIN design-matrix
:END
```

# Barcode filtering 

:BEGIN ref-filtering
We filter out barcodes that were not present in the original pool, e.g., due to manufacturing defects in the screen library.
We use a subset of reference samples to compute the abundances in the pool,
and we define a threshold on the log-average CPM by defining small outliers based on the median absolute deviation.

```{r}
is.ref <- SummarizedExperiment::colData(original)[[<%= REFERENCE_FIELD %>]] %in% <%= REFERENCE_LEVELS %>
summary(is.ref)

ref.counts <- SummarizedExperiment::assay(original, <%= ASSAY %>)[,is.ref,drop=FALSE]
ref.non.empty <- which(Matrix::rowSums(ref.counts) > 0) # ignoring all-zero rows.
ref.ab <- edgeR::aveLogCPM(ref.counts[ref.non.empty,,drop=FALSE])
hist(ref.ab, xlab="Reference average log-CPM") 

# Defining the threshold. 
ref.med.ab <- median(ref.ab)
ref.med.ab
ref.mad.ab <- mad(ref.ab, center=ref.med.ab)
ref.threshold <- ref.med.ab - <%= NUM_MADS %> * ref.mad.ab
ref.threshold

# Applying the filter.
ref.filtered <- logical(nrow(y))
ref.filtered[ref.non.empty] <- ref.ab >= ref.threshold
summary(ref.filtered)
y <- y[ref.filtered,]
```

:END

:BEGIN filter-default
We also filter out low-abundance barcodes to improve the accuracy of the mean-variance trend fit.
This also reduces computational work and the severity of the multiple testing correction.
We use `r BiocStyle::Biocpkg("edgeR")`'s default filtering strategy,
which only retains barcodes with coverage above a threshold in at least $n$ samples.

```{r}
filtered <- edgeR::filterByExpr(y, <%= FILTER_OPTS %>, large.n=0)
y <- y[filtered,]
summary(filtered)
```

The minimum threshold is defined as a CPM equivalent to a count of 10, adjusted for differences in library size.
$n$ is defined as 70% of the size of the smallest group in the experimental design.
(We set `large.n=0` to allow a barcode to be below the threshold in some of the samples of a small group.) 
:END

:BEGIN filter-none
We'll omit the filtering - all barcodes will be tested for differential abundance.
:END

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runScreen.R
\name{runScreen}
\alias{runScreen}
\title{Differential abundance for functional screens}
\usage{
runScreen(
  x,
  groups,
  comparisons,
  covariates = NULL,
  block = NULL,
  subset.factor = NULL,
  subset.levels = NULL,
  subset.groups = TRUE,
  design = NULL,
  contrasts = NULL,
  dc.block = NULL,
  robust = TRUE,
  trend = FALSE,
  quality = TRUE,
  lfc.threshold = 0,
  filter.reference.factor = NULL,
  filter.reference.levels = NULL,
  filter.num.mads = 3,
  filter.default = TRUE,
  norm.control.barcodes = NULL,
  norm.control.genes = NULL,
  norm.control.type.field = NULL,
  norm.control.types = NULL,
  norm.tmm = TRUE,
  gene.field = NULL,
  report.summary = TRUE,
  summary.threshold = 0.05,
  consolidation = c("simes", "fry", "holm-min"),
  fry.args = list(),
  holm.min.n = 3,
  holm.min.prop = 0.3,
  assay = 1,
  row.data = gene.field,
  gene.data = NULL,
  metadata = NULL,
  output.dir = "voom",
  author = NULL,
  dry.run = FALSE,
  save.results = TRUE,
  suppress.plots = FALSE
)
}
\arguments{
\item{x}{A \link[SummarizedExperiment]{SummarizedExperiment} object containing read counts for each barcode (row) and sample (column).
Alternatively, the output of \code{\link[augere.core]{wrapInput}} that refers to a SummarizedExperiment.}

\item{groups}{String specifying the \code{\link[SummarizedExperiment]{colData}(x)} column containing the grouping factor of interest,
see \code{\link[augere.de]{processSimpleDesignMatrix}} for more details.
This may be \code{NULL} for experimental designs with no groups, e.g., \code{covariates} only.
Ignored if \code{design} and \code{contrasts} are provided.}

\item{comparisons}{Character vector specifying two or more groups to compare from \code{groups}, or the covariate to be tested from \code{covariates}.
Alternatively, or a list of such character vectors specifying multiple comparisons to perform.
See \code{\link[augere.de]{processSimpleComparisons}} for more details.
Ignored if \code{design} and \code{contrasts} are provided.}

\item{covariates}{Character vector specifying the \code{\link[SummarizedExperiment]{colData}(x)} columns containing continuous covariates of interest,
see \code{\link[augere.de]{processSimpleDesignMatrix}} for more details.
Ignored if \code{design} and \code{contrasts} are provided.}

\item{block}{Character vector specifying the \code{\link[SummarizedExperiment]{colData}(x)} columns containing additional (uninteresting) blocking factors,
see \code{\link[augere.de]{processSimpleDesignMatrix}} for more details.
Ignored if \code{design} and \code{contrasts} are provided.}

\item{subset.factor}{String specifying the \code{\link[SummarizedExperiment]{colData}(x)} column containing the factor to use for subsetting.}

\item{subset.levels}{Vector containing the levels of the \code{subset.factor} to be retained.}

\item{subset.groups}{Boolean indicating whether to automatically subset the dataset to only those samples assigned to groups in \code{comparisons}.
Setting this to \code{TRUE} sacrifices some residual degrees of freedom for greater robustness against variability in irrelevant groups.
Ignored if \code{design} and \code{contrasts} are provided.
Also ignored if \code{covariates} is provided, as all samples are informative for a continuous covariate.}

\item{design}{Matrix, function, or formula specifying the experimental design, see \code{\link[augere.de]{processCustomDesignMatrix}} for details.
If this and \code{contrasts} are specified, \code{groups}, \code{block}, \code{covariates}, \code{comparisons} and \code{subset.groups} are ignored.}

\item{contrasts}{String, function or matrix specifying a custom contrast, or a list of such objects; see \code{\link[augere.de]{processCustomContrasts}} for details.
If this and \code{design} are specified, \code{groups}, \code{block}, \code{covariates}, \code{comparisons} and \code{subset.groups} are ignored.}

\item{dc.block}{String specifying the blocking factor to use in \code{\link[limma]{duplicateCorrelation}}.
Typically used for uninteresting factors that cannot be used in \code{block} as they are confounded with the factors of interest.
No additional blocking is performed if \code{NULL}.}

\item{robust}{Boolean indicating whether robust empirical Bayes shrinkage should be used in \code{\link[limma]{eBayes}}.
Setting this to \code{TRUE} sacrifices some precision for improved robustness against genes with extreme variances.}

\item{trend}{Boolean indicating whether variances should be shrunk towards a trend in \code{\link[limma]{eBayes}}.
Usually unnecessary as the observation weights already account for the mean-variance relationship.}

\item{quality}{Boolean indicating whether quality weighting should be performed.
This reduces the influence of low-quality samples at the cost of more computational work.}

\item{lfc.threshold}{Number specifying a threshold on the log-fold change in \code{\link[limma]{treat}}.
If zero, \code{\link[limma]{eBayes}} will be used instead.}

\item{filter.reference.factor}{String specifying \code{\link[SummarizedExperiment]{colData}(se)} column that indicates whether a sample is a reference.
This is used to filter out barcodes that are not present in the original barcode library.}

\item{filter.reference.levels}{Character vector containing the reference levels in the \code{filter.reference.factor} column.
Only used if \code{filter.reference.factor} is supplied.}

\item{filter.num.mads}{Number specifying the number of median absolute deviations below the median to define an outlier threshold for filtering barcodes.
Only used if \code{filter.reference.factor} is supplied.}

\item{filter.default}{Boolean indicating whether to filter barcodes using the default \pkg{edgeR} method, i.e., \code{\link[edgeR]{filterByExpr}}.
If \code{TRUE} and \code{filter.reference.factor} is supplied, the default filtering is applied in addition to the reference-based filtering.
Otherwise, it is applied alone.}

\item{norm.control.barcodes}{A named list of character vectors containing one or more sets of control barcodes.
Each vector should contain the names of barcodes, corresponding to the row names of \code{se}.
The names of the vectors will be stored in the metadata.}

\item{norm.control.genes}{A named list containing one or more sets of control genes.
Each vector should contain the names of genes, corresponding to the entries of the \code{gene.field} column.
The names of the vectors will be stored in the metadata.
Only used if \code{gene.field} is supplied.}

\item{norm.control.type.field}{String specifying the \code{\link[SummarizedExperiment]{rowData}(se)} column containing the feature type for each barcode.}

\item{norm.control.types}{Character vector containing the control feature types in the \code{norm.type.field} column. 
Only used if \code{norm.type.field} is supplied.}

\item{norm.tmm}{Boolean indicating whether TMM normalization should be used.
If \code{FALSE}, normalization is instead performed using the library size for each sample.}

\item{gene.field}{String specifying the \code{rowData(se)} column that contains the gene identity for each barcode.
If \code{NULL}, consolidation of barcode-level statistics into per-gene inferences will not be performed.}

\item{report.summary}{Boolean indicating whether to report barcode-level summaries within the per-gene data frames.
Only used if \code{gene.field} is supplied.}

\item{summary.threshold}{Number specifying the FDR threshold when summarizing the number of significant barcodes per gene.
Only used if \code{report.summary=TRUE}.}

\item{consolidation}{Character vector specifying the consolidation method(s) to convert per-barcode statistics into per-gene results.
This can be zero, one or more of:
\itemize{
\item \code{"simes"}, which uses \code{\link[metapod]{groupedSimes}} to combine barcode-level p-values into a single per-gene p-value. 
This is the most sensitive approach for detecting a small number of barcodes (possibly just 1) that are differentially abundant.
\item \code{"holm-min"}, which uses \code{\link[metapod]{groupedHolmMin}} to combine barcode-level p-values into a single per-gene p-value. 
This should be used when a minimum number/proportion of barcodes for a gene is expected to exhibit differential abundance. 
\item \code{"fry"}, which uses \code{\link[limma]{fry}} to test for differential abundance across all barcodes for a gene.
This favors consistent differences across the majority of barcodes for a given gene.
However, it is not compatible with ANOVA-like contrasts and will ignore any \code{lfc.threshold > 0}.
}
Only used if \code{gene.field} is supplied.}

\item{fry.args}{Named list of additional arguments to pass to \code{\link[limma]{fry}}.}

\item{holm.min.n}{Integer specifying the minimum number of significant barcodes per gene when \code{consolidation="holm"},
see the \code{min.sig.n=} in \code{?\link[metapod]{groupedHolmMin}} for details.}

\item{holm.min.prop}{Integer specifying the minimum proportion of significant barcodes per gene when \code{consolidation="holm"},
see the \code{min.sig.prop=} in \code{?\link[metapod]{groupedHolmMin}} for details.}

\item{assay}{String or integer specifying the assay of \code{x} containing the count matrix.}

\item{row.data}{Character vector specifying the \code{\link[SummarizedExperiment]{rowData}(x)} columns containing extra gene annotations to include in the result DataFrames.}

\item{gene.data}{Character vector containing the names of \code{\link[SummarizedExperiment]{rowData}(se)} columns to add to the per-gene result tables.
If a gene has multiple barcodes, the row corresponding to the first barcode is used.}

\item{metadata}{Named list of additional metadata to store alongside each result.}

\item{output.dir}{String containing the path to an output directory in which to write the Rmarkdown file and save results.}

\item{author}{Character vector containg the names of the authors.
If \code{NULL}, defaults to the current user.}

\item{dry.run}{Boolean indicating whether to perform a dry run.
This generates the Rmarkdown report in \code{output.dir} but does not execute the analysis.}

\item{save.results}{Boolean indicating whether the results should be saved to file.}

\item{suppress.plots}{Boolean indicating whether plots should be suppressed.
This can be set to \code{TRUE} for faster execution.}
}
\value{
A Rmarkdown report named \code{report.Rmd} is written inside \code{output.dir} that contains the analysis commands.

If \code{dry.run=FALSE}, a list is returned containing:
\itemize{
\item \code{barcode}, a named list of \link[S4Vectors]{DataFrame}s containing barcode-level result tables.
Each DataFrame corresponds to a comparison/contrast where each row corresponds to a barcode (i.e., row) in \code{se}.
Each DataFrame contains the following columns:
\itemize{
\item \code{AveAb}, the average abundance.
\item \code{t}, the t-statistic.
(For non-ANOVA-like contrasts only.)
\item \code{F}, the F-statistic.
(For ANOVA-like contrasts only.)
\item \code{LogFC}, the log-fold change.
(For non-ANOVA-like contrasts only.)
\item \code{LogFC.<COLUMN>}, the log-fold change corresponding to each column of the contrast matrix.
(For ANOVA-like contrasts only.)
\item \code{PValue}, the p-value;
\item \code{FDR}, the Benjamini-Hochberg-adjusted p-value.
}
\item \code{gene}, a named list of lists containing one entry per method in \code{consolidation}.
Each inner list contains one \link[S4Vectors]{DataFrame} per contrast where each row corresponds to a gene (not barcode). 
Each DataFrame contains at least the following columns:
\itemize{
\item \code{NumBarcodes}, the number of barcodes per gene (possibly after filtering).
\item \code{PValue}, the p-value for differential abundance across all barcodes for the gene.
\item \code{FDR}, the Benjamini-Hochberg-adjusted p-value.
\item \code{Direction}, the overall direction of change for all barcodes of the gene.
(For non-ANOVA-like contrasts only.)
\item \code{NumUp}, the number of barcodes with a significant increase in abundance.
(For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
\item \code{NumDown}, the number of barcodes with a significant decrease in abundance.
(For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
\item \code{LogFC}, the log-fold change of the barcode with the lowest p-value.
(For non-ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
\item \code{NumSig}, the number of significant barcodes.
(For ANOVA-like contrasts only, when \code{report.summary=TRUE}.)
\item \code{AveAb}, the average abundance of the barcode with the lowest p-value.
}
Only reported if \code{gene.field} is not \code{NULL}.
\item \code{normalized}, a copy of \code{x} with normalized abundance values, possibly subsetted by sample.
This contains:
\itemize{
\item \code{lib.size} and \code{norm.factors} columns in its \code{\link[SummarizedExperiment]{colData}},
containing the library sizes and normalization factors, respectively.
\item a \code{retained} column in its \code{\link[SummarizedExperiment]{rowData}},
indicating whether a gene was retained after filtering.
\item a \code{logcounts} assay, containing the log-normalized counts.
}
\code{normalized} may be subsetted by sample, depending on \code{subset.factor}, \code{subset.group}, etc.
}
If \code{save.results=TRUE}, the results are saved in a \code{results} directory inside \code{output}.

If \code{dry.run=TRUE}, \code{NULL} is returned.
Only the Rmarkdown report is saved to file.
}
\description{
Use \code{\link[limma]{voom}} to test for differential abundance of barcodes in a functional screen.
}
\section{Reference filtering}{

A reference sample should represent the barcode distribution before any perturbation, e.g., time zero in a time course.
All barcodes should have similar abundances in the reference samples as they should be present at the same molarity in the original barcode library.
If a barcode has very low abundance, it was probably missing from the original library due to some manufacturing defect.

To identify these low outliers, we compute the average abundance across reference samples for each barcode.
We define a filtering threshold based on the median absolute deviation (MAD) below the median of the average abundances across barcodes.
Barcodes with average abundances below this threshold are discarded.

% This approach is a little suspect if the reference samples are being compared as it's not independent of the comparison.
% Specifically, we could enrich for barcodes that are spuriously upregulated in the reference.
% Fortunately, the density of barcodes at the outlier filter boundary should be so low that any biases should not be noticeable.

We also use \code{\link[edgeR]{filterByExpr}} to remove low-abundance barcodes. 
This ensures that all remaining barcodes have sufficiently large counts for \code{\link[limma]{voom}}, 
especially if the reference samples themselves are not used in the rest of the analysis.
}

\section{Control normalization}{

Control barcodes might not target any gene (non-targeting controls, or NTCs) or they might target non-essential genes (NEGs).
We assume that such barcodes do not genuinely change in abundance across conditions, allowing us to use them to compute normalization factors.
The choice of control barcodes can be made by one or more of the \code{norm.barcodes}, \code{norm.genes} and \code{norm.types} arguments.
If more than one of these modes is provided, the union of barcodes is used. 

By default, we use TMM normalization (see \code{\link[edgeR]{calcNormFactors}}) on the control barcodes. 
This avoids composition biases and provides some robustness against changes in abundance due to inadvertent biological activity.
If \code{norm.tmm=FALSE}, we instead use the total sum of counts across the controls to derive normalization factors.
This can be more precise but is more sensitive to genuine changes in abundance.

If no control barcodes are specified, normalization uses all barcodes that remain after filtering.
If \code{norm.tmm=TRUE}, TMM normalization is performed on all (filtered) barcodes.
Otherwise, the total sum of counts across all (filtered) barcodes is used.
}

\examples{
# Creating an example dataset.
mu <- 2^runif(1000, 0, 5)
grouping <- rep(c("A", "B", "ctrl"), each=3)
counts <- matrix(rnbinom(length(mu)* length(grouping), mu=mu, size=20), ncol=length(grouping))
rownames(counts) <- sprintf("BARCODE-\%s", seq_along(mu))

library(SummarizedExperiment)
se <- SummarizedExperiment(list(counts=counts))
rowData(se)$type <- sample(c("NTC", "NEG", "other"), length(mu), replace=TRUE)
rowData(se)$gene <- paste0("GENE-", sample(LETTERS, length(mu), replace=TRUE))
colData(se)$group <- grouping

output <- tempfile()
res <- runScreen(
    se,
    groups="group",
    comparisons=c("A", "B"),
    norm.control.type.field="type",
    norm.control.types="NEG",
    filter.reference.factor="group",
    filter.reference.levels="ctrl",
    gene.field="gene",
    output.dir=output
)

list.files(output, recursive=TRUE)
res$barcode[[1]]
res$gene$simes[[1]]
res$normalized

}
\author{
Aaron Lun, Jean-Philippe Fortin
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/augere.screen-package.R
\docType{package}
\name{augere.screen-package}
\alias{augere.screen}
\alias{augere.screen-package}
\title{augere.screen: Automatic Generation of Functional Screen Analyses}
\description{
Implements pipelines for generating functional screen analysis reports in the augere framework. This uses voom to test for differential abundance of barcodes with consolidation into gene-level statistics. Each pipeline function generates a self-contained Rmarkdown report with all of the steps required to reproduce the analysis.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/augere-bioinfo/augere.screen}
  \item Report bugs at \url{https://github.com/augere-bioinfo/augere.screen/issues}
}

}
\author{
\strong{Maintainer}: Aaron Lun \email{infinite.monkeys.with.keyboards@gmail.com} (\href{https://orcid.org/0000-0002-3564-4813}{ORCID})

}
